#define __COMMAND1_C

#include <ultra64.h>
#include "main.h"
#include "nsfont.h"
#include "menu.h"

#ifdef V2_0G
#  include <leoappli.h>
#  include "myleoapi.h"
#else
#  include <leo.h>
#endif

#include "n64dd.h"
#include "command1.h"
#include "command2.h"

/*****************************************************************
 *		˥塼:ޥ
 */
void draw_menu_main( int cur ){
	int i, f;

	f = cur? frame: 7;

	text_size( 20, 20 );
	text_pos( main_menu_window.x+2, main_menu_window.y+1 );
	text_cur( 0, 0 );
	text_prepare( &glistp );

	/* ޥɰɽ */
	for( i=1; command_string[i][0]>0; i++ ){
		if ( (i != exec_command) )
			text_color( 130, 130, 130 );
		else
			text_color( 255, 100+155*(f>>2 & 1), 100+155*(f>>2 & 1) );

		text_print( &glistp, command_string[i] );
		text_print( &glistp, "\n" );
	}
}

/*****************************************************************
 *		֥˥塼ե
 */
void draw_sub_menu1( int cur ){
	int i, f;

	f = cur? frame: 7;

	text_size( 20, 20 );
	text_pos( sub_menu1_window.x+2, sub_menu1_window.y+1 );
	text_cur( 0, 0 );
	text_prepare( &glistp );

	for( i=0; (file_name_string[shown_file_num + i][0]>0) && (i<10); i++ ){
		if ( i != selected_file_num )
			text_color( 130, 130, 130 );
		else
			text_color( 255, 100+155*(f>>2 & 1), 100+155*(f>>2 & 1) );

		text_print( &glistp, file_name_string[shown_file_num + i] );
		text_print( &glistp, "\n" );
	}
}

/*****************************************************************
 *		֥˥塼ǧ
 */
void draw_sub_menu2( int cur ){
	int f;

	f = cur? frame: 7;

	text_size( 20, 4 );
	text_pos( sub_menu2_window.x+2, sub_menu2_window.y+1 );
	text_cur( 0, 0 );
	text_prepare( &glistp );

	text_color( 255, 70, 70 );
	text_cur( 1, 0 );
	text_print( &glistp, "** CONFIRM **\n" );

	if ( command_confirm == 0 )		text_color( 255, 100+155*(f>>2 & 1), 100+155*(f>>2 & 1) );
	else							text_color( 130, 130, 130 );
	text_print( &glistp, "EXECUTE  " );

	if ( command_confirm == 1 )		text_color( 255, 100+155*(f>>2 & 1), 100+155*(f>>2 & 1) );
	else							text_color( 130, 130, 130 );
	text_print( &glistp, "CANCEL" );
}

/*****************************************************************
 *		֥˥塼ե륵
 */
void draw_sub_menu3( int cur ){
	char t[16];
	int f;

	f = cur? frame: 7;

	text_size( 20, 2 );
	text_pos( sub_menu3_window.x+2, sub_menu3_window.y+1 );
	text_cur( 0, 0 );
	text_prepare( &glistp );

	text_color( 255, 255, 255 );
	text_print( &glistp, "SIZE? (Byte)\n " );

	text_color( 255, 100+155*(f>>2 & 1), 100+155*(f>>2 & 1) );
	sprintf( t, "0x%07x", file_size );
	text_print( &glistp, t );
}

/*****************************************************************
 *		֥˥塼ե
 */
void draw_sub_menu4( int cur ){
	int i, f;

	f = cur? frame: 7;

	text_size( 20, 20 );
	text_pos( sub_menu4_window.x+2, sub_menu4_window.y+1 );
	text_cur( 0, 0 );
	text_prepare( &glistp );

	for( i=0; pict_name_string[i][0]>0; i++ ){
		if ( i != selected_pict_num )
			text_color( 130, 130, 130 );
		else
			text_color( 255, 100+155*(f>>2 & 1), 100+155*(f>>2 & 1) );

		text_print( &glistp, pict_name_string[i] );
		text_print( &glistp, "\n" );
	}
}

/*****************************************************************
 *		֥˥塼FAT ɥ쥹
 */
void draw_sub_menu5( int cur ){
	int f;
	char t[64];

	f = cur? frame: 7;

	text_size( 20, 2 );
	text_pos( sub_menu5_window.x+2, sub_menu5_window.y+1 );
	text_cur( 0, 0 );
	text_prepare( &glistp );

	text_color( 255, 255, 255 );
	text_print( &glistp, "ADDRESS? (offset)\n " );

	text_color( 255, 100+155*(f>>2 & 1), 100+155*(f>>2 & 1) );
	sprintf( t, "0x%05x", fat_address );
	text_print( &glistp, t );
}

/*****************************************************************
 *		֥˥塼FAT 
 */
void draw_sub_menu6( int cur ){
	int i, j;
	char t[1024], *sp;

	/* ޥɼ¹ */
	while(1){
		/* ǥå */
		n64dd_check_valid();

		/* 顼ȯ:ǥؤƤʤƥ */
		if ( n64dd_error_no == LEO_ERROR_MEDIUM_MAY_HAVE_CHANGED ){
			n64dd_error_no = n64dd_newdisk();
			if ( n64dd_error_no == 0 ) continue;
		}

		/* ¾Υ顼 */
		if ( n64dd_error_no != 0 ){
			text_pos( sub_menu6_window.x+2, sub_menu6_window.y+1 );
			show_error_message_current( n64dd_error_no );
			break;
		}

		/* ޥɼ¹ */
		text_size( 55, 20 );
		text_pos( sub_menu6_window.x+2, sub_menu6_window.y+1 );
		text_cur( 0, 0 );
		text_color( 255, 255, 255 );
		text_prepare( &glistp );

		sp = t;
		for ( i=0; i<0x100; i+=0x10 ){
			sprintf( sp, "%04x: ", show_fat_address +i );
			sp += 6;
			for( j=0; j<16; j++ ){
				sprintf( sp, "%02x ", (u8)n64dd_t.a[ show_fat_address +i +j ] );
				sp += 3;
			}
			*sp = '\n';
			sp++;
		}
		*sp = '\0';

		text_print( &glistp, t );
		break;
	}
}

/*****************************************************************
 *		ɽ˥塼
 */
void draw_wait_menu( int cur ){
	int f;

	f = cur? frame: 7;

	text_size( 50, 2 );
	text_pos( 21, 10 );
	text_cur( 0, 0 );
	text_prepare( &glistp );

	text_color( 255, 255, 100+155*(f>>2 & 1) );
	text_print( &glistp, wait_menu_string );
}

/*****************************************************************
 *		֥˥塼FAT ɥ쥹
 */
void draw_sub_menu7( int cur ){
	char t[ 4096 ], *sp;
	int i, j, k, n;
	int g[256];	
	int start, end;

	n64dd_File_info	*e;


	/* ޥɼ¹ */
	while(1){
		/* ǥå */
		n64dd_check_valid();
				
		/* 顼ȯ:ǥؤƤʤƥ */
		if ( n64dd_error_no == LEO_ERROR_MEDIUM_MAY_HAVE_CHANGED ){
			n64dd_error_no = n64dd_newdisk();
			if ( n64dd_error_no == 0 ) continue;
		}
				
		/* ¾Υ顼 */
		if ( n64dd_error_no != 0 ){
			text_pos( sub_menu6_window.x+2, sub_menu6_window.y+1 );
			show_error_message_current( n64dd_error_no );
			break;
		}

		for( k=0; k<256; k++ ) g[k] = -1;

		/* ӥ֥FAT ɽ */
		if (  (n = n64dd_how_many_file()) >= 0 ){
			for( i=0; i<n; i++ ){
				if ( n64dd_get_file_info_pointer( i, &e ) == 0 ){
					for( j=0; ; j++ ){

						/* Ǽꥢ*/
						start = e->info[j].startLBA;
						end   = e->info[j].startLBA + e->info[j].useLBA;
						if ( start == 0 ) break;

						if ( start < vfat_address )		k = 0;
						else							k = start - vfat_address;

						for( ; (k < end - vfat_address)&&(k < 256); k++ ) 	g[k]=i;
					}
				}
			}
		}

		/* ɽ */
		text_size( 55, 20 );
		text_pos( sub_menu6_window.x+2, sub_menu6_window.y+1 );
		text_cur( 0, 0 );
		text_color( 255, 255, 255 );
		text_prepare( &glistp );

		sp = t;
		for( i=0; i<16; i++ ){
			sprintf( sp, "%04x ", vfat_address + i*16 );
			sp+=5;

			for ( j=0; j<16; j++ ){
				if ( (k = g[i*16+j]) >= 0 ){
					sprintf( sp, "@#%x%x%x%02x@- ", ((k+4)%8)+8, ((k+5)%8)+8, (k%8)+8, k%100 );
					sp += 10;
				}
				else{
					if ( i*16+j + vfat_address == 0 ){
						strcpy( sp, "@#3f3FT@- " );
						sp+=10;
					}
					else{
						strcpy( sp, "-- " );
						sp += 3;
					}
				}
			}
			*sp = '\n';
			sp++;
		}
		*sp = '\0';

		text_print( &glistp, t );
		break;
	}
}

/****************************************************************
 *		顼ȯåɽ(current ܡɤɽ)
 */
void show_error_message_current( int num )
{
	char t[64];

	text_size( 55, 20 );
	text_cur( 0, 0 );
	text_color( 255, 255, 255 );

	strcpy( t, " ERROR." );

	switch( num ){
	case N64DD_MEDIA_NOT_INIT:
		strcat( t, " Media not initialized.\n\n" );
		break;
	case LEO_ERROR_MEDIUM_NOT_PRESENT:
		strcat( t, " No disk.\n\n" );
		break;
	case N64DD_AREA_LACKED:
		strcat( t, " No enough area left.\n\n" );
		break;
	case N64DD_NOT_FOUND:
		strcat( t, " Such file not found.\n\n" );
		break;
	case N64DD_ARGUMENT_ILLEGAL:
		strcat( t, " Argument illegal.\n\n" );
		break;
	case N64DD_READ_ONLY_MEDIA:
		strcat( t, " This media is read only.\n\n" );
		break;
	default:
		sprintf( t, " Error NO. %d.\n\n", num );
		break;
	}

	text_print_pre( &glistp, t );
}
