#define __COMMAND2_C

#include <ultra64.h>

#ifdef V2_0G
#  include <leoappli.h>
#  include "myleoapi.h"
#else
#  include <leo.h>
#endif

#include "define.h"
#include "main.h"
#include "n64dd.h"
#include "cg_area.h"
#include "menu.h"
#include "picture_buf.h"
#include "command2.h"

int		exec_trigger = 0;

/*****************************************************************
 *		ޥɼ¹
 */
extern unsigned short mrdo_data[];
void do_command( void )
{
	char t[128];

	/* ================ ޥɽɽ */
	if ( current_menu == MENU_WAIT_MENU ){
		switch( exec_command ){
		case EXEC_SAVE:
			strcpy( wait_menu_string, "Now saving..." );
			break;
		case EXEC_LOAD:
			strcpy( wait_menu_string, "Now loading..." );
			break;
		case EXEC_DELETE:
			strcpy( wait_menu_string, "Now deleting..." );
			break;
		case EXEC_LS:
			strcpy( wait_menu_string, "Now checking disk drive..." );
			break;
		case EXEC_DF:
			strcpy( wait_menu_string, "Now checking disk drive..." );
			break;
		case EXEC_FORMAT:
			strcpy( wait_menu_string, "Now initializing media..." );
			break;
		case EXEC_PICT:
			strcpy( wait_menu_string, "Now changing picture..." );
			break;
		}
		if ( wait_menu_status == 1 ){
			current_menu = MENU_OUTPUT_MENU;
			output_menu_status = MENU_OPEN_CNT / 2;		/* ä᤯ */
			exec_trigger = 1;
		}
		return;
	}

	/* ================ ޥɼ¹Ԥȷ̽ */
	if ( (output_menu_status == 1) && (exec_trigger == 1) ){
		exec_trigger = 0;

		/* ================ ʤ */
		if ( exec_command == EXEC_NONE ){
			exec_on = 0;
			exec_command = 0;
			/* ??? */
		}

		/* ================ ɻ */
		if ( exec_command == EXEC_PICT ){
			int 	i;

			if ( selected_pict_num == 0 ){
				for( i=0; i<320*240; i++ ) cg_data[ i ] = 0x0;
				text_setting( "clear picture.\n\n" );
			}
			if ( (selected_pict_num >= 1) && (selected_pict_num <= 9) ){
				pict_trans( selected_pict_num );
				for( i=0; i<320*240; i++ ) cg_data[i] = picture_buf[i+(sizeof(Gfx))];
				sprintf( t, "set picture %s.\n\n", pict_name_string[ selected_pict_num ] );
				text_setting( t );
			}
		}

		/* ================ եΥ */
		if( exec_command == EXEC_SAVE ){
			s32		size;

			size = file_size;

			/* ޥɽ */
			sprintf( t, "save %s (0x%0x byte)\n", file_name_string[ shown_file_num + selected_file_num ], size );
			text_setting( t );

			while(1){
				/*  */
				if ( n64dd_save( file_name_string[ shown_file_num + selected_file_num ], (u32*)cg_data, size, "TEST", "64CG" ) == 0 ){
					text_setting( " success.\n\n" );
					break;
				}

				/* 顼ȯ:ǥؤƤʤƥ */
				if ( n64dd_error_no == LEO_ERROR_MEDIUM_MAY_HAVE_CHANGED ){
					if ( n64dd_newdisk() == 0 ) continue;
				}

				/* ¾Υ顼 */
				show_error_message( n64dd_error_no );
				break;
			}
		}

		/* ================ եꥹ */
		if ( exec_command == EXEC_LS ){
			int i, j, n;
			char fname[128];
			char creator[8];
			char filetype[8];
			s32 fsize;
			n64dd_File_info		*e;

			/* ޥɽ */
			text_setting( "**** FILE LIST ****\n" );

			/* եꥹ */
			while(1){
				if (  (n = n64dd_how_many_file()) >= 0 ){
					if ( n == 0 )
						text_setting( "NO FILE.\n\n" );
					else{
						for( i=0; i<n; i++ ){
							if ( n64dd_get_file_info_pointer( i, &e ) == 0 ){

								fsize = e->size;
								strcpy( fname,    e->name );
								strncpy( creator,  e->creator,  4 );
								strncpy( filetype, e->filetype, 4 );

								strlenset( fname,   15 );
								strlenset( creator,  4 );
								strlenset( filetype, 4 );

								sprintf( t, " %s   0x%x(%d)byte  %s  %s\n", fname, fsize, fsize, creator, filetype );
								text_setting( t );

								sprintf( t, "  %02x/%02x/%02x  %02x:%02x:%02x\n",
										 e->time.yearlo, e->time.month, e->time.day, e->time.hour, e->time.minute, e->time.second );
								text_setting( t );

								for( j=0; ; j++ ){
									int start, use;
									if ( (start = e->info[j].startLBA) == 0 ) break;
									use   = e->info[j].useLBA;

									sprintf( t, "    FAT: from 0x%x (0x%x)\n", start, use );
									text_setting( t );
								}
							}
						}
						text_setting( "\n" );
					}
					break;
				}
				
				/* 顼ȯ:ǥؤƤʤƥ */
				if ( n64dd_error_no == LEO_ERROR_MEDIUM_MAY_HAVE_CHANGED ){
					if ( n64dd_newdisk() == 0 ) continue;
				}
				
				/* ¾Υ顼 */
				show_error_message( n64dd_error_no );
				break;
			}
		}

		/* ================ եޥå */
		if ( exec_command == EXEC_FORMAT ){
			/* ޥɽ */
			text_setting( "Initialize media.\n" );

			while(1){
				if ( n64dd_media_init() == 0 ){
					text_setting( "success.\n\n" );
					break;
				}

				/* 顼ȯ:ǥؤƤʤƥ */
				if ( n64dd_error_no == LEO_ERROR_MEDIUM_MAY_HAVE_CHANGED ){
					if ( n64dd_newdisk() == 0 ) continue;
				}
				
				/* ¾Υ顼 */
				show_error_message( n64dd_error_no );
				break;
			}
		}

		/* ================ ɤ߹ */
		if ( exec_command == EXEC_LOAD ){
			u32		size;

			n64dd_error_no = 0;
			size = file_size;

			/* ޥɽ */
			if ( size == 0 ){
				sprintf( t, "load %s (original size).\n", file_name_string[ shown_file_num + selected_file_num ] );
			}
			else{
				sprintf( t, "load %s (0x%0x byte).\n", file_name_string[ shown_file_num + selected_file_num ], size );
			}
			text_setting( t );

			/* ɤ߹ߥ(0ä饻ֻΥʤΤϤʽɬפʤɡ
			 * 礭¤Ƥ뤫) */
			if ( size == 0 ){
				while(1){
					if ( n64dd_get_file_info_by_name( file_name_string[ shown_file_num + selected_file_num ], &size, NULL, NULL, NULL ) < 0 ){
						if ( n64dd_error_no == LEO_ERROR_MEDIUM_MAY_HAVE_CHANGED ){
							if ( n64dd_newdisk() == 0 ) continue;
						}
					}

					/* ¾Υ顼 */
					show_error_message( n64dd_error_no );
					break;
				}
			}

			/* ޥɼ¹ */
			if ( n64dd_error_no == 0 ){

				/* (:ɤ߹ΰ礭Թˤꡢ320*240*2 ХȰʾɤ߹ޤ) */
				if ( size > 320*240*2 ){
					text_setting( " (Sorry, This system has only 0x25800 byte\n  as read buffer.)\n" );
					size = 320*240*2;
				}

				while(1){
					if ( n64dd_load_halfway( file_name_string[ shown_file_num + selected_file_num ], (u32*)cg_data, 0, size ) == 0 ){
					/*if ( n64dd_load( file_name_string[ shown_file_num + selected_file_num ], (u32*)cg_data, size ) == 0 ){*/
						text_setting( " success.\n\n" );
						break;
					}

					/* 顼ȯ:ǥؤƤʤƥ */
					if ( n64dd_error_no == LEO_ERROR_MEDIUM_MAY_HAVE_CHANGED ){
						if ( n64dd_newdisk() == 0 ) continue;
					}

					/* ¾Υ顼 */
					show_error_message( n64dd_error_no );
					break;
				}
			}
		}

		/* ================ ǥ */
		if ( exec_command == EXEC_DF ){
			int i;

			/* ޥɽ */
			text_setting( "information about disk.\n" );

			/* ޥɼ¹ */
			while(1){
				/* ǻȤƤ 64DD ΤΥޥɤϡǥǥ¸ߤ
				   åƤʤͽ n64dd_chack_valid ǤƤȡ*/

				/* ǥå */
				n64dd_check_valid();
				
				/* 顼ȯ:ǥؤƤʤƥ */
				if ( n64dd_error_no == LEO_ERROR_MEDIUM_MAY_HAVE_CHANGED ){
					if ( n64dd_newdisk() == 0 ) continue;
				}

				/* ¾Υ顼 */
				if ( n64dd_error_no != 0 ){
					show_error_message( n64dd_error_no );
					break;
				}
				
				sprintf( t, " 64DD FAT is located from block %d to %d.\n", n64dd_cap.startLBA, n64dd_cap.endLBA );
				text_setting( t );
				i = n64dd_ftable_left();
				sprintf( t, " 0x%x(%d) filetable space left.\n", i, i );
				text_setting( t );
				i = n64dd_left_LBAbyte();
				sprintf( t, " 0x%x(%d) bytes left on disk.\n\n", i, i );
				text_setting( t );
				break;
			}
		}

		/* ================ ե */
		if ( exec_command == EXEC_DELETE ){

			/* ޥɽ */
			sprintf( t, "delete %s.\n", file_name_string[ shown_file_num + selected_file_num ] );
			text_setting( t );

			/* ޥɼ¹ */
			while(1){
				if ( n64dd_delete_file( file_name_string[ shown_file_num + selected_file_num ] ) == 0 ){
					text_setting( "success.\n\n" );
					break;
				}

				/* 顼ȯ:ǥؤƤʤƥ */
				if ( n64dd_error_no == LEO_ERROR_MEDIUM_MAY_HAVE_CHANGED ){
					if ( n64dd_newdisk() == 0 ) continue;
				}

				/* ¾Υ顼 */
				if ( n64dd_error_no != 0 ){
					show_error_message( n64dd_error_no );
					break;
				}
			}
		}


		wait_menu_status = MENU_CLOSE_CNT;
		current_menu = MENU_FINISH_MENU;
	}
}

/****************************************************************
 *		顼ȯåɽ
 */
void show_error_message( int num )
{
	char t[64];

	if ( num == 0 ) return;

	text_setting( " ERROR." );

	switch( num ){
	case N64DD_MEDIA_NOT_INIT:
		text_setting( " Media not initialized.\n\n" );
		break;
	case LEO_ERROR_MEDIUM_NOT_PRESENT:
		text_setting( " No disk.\n\n" );
		break;
	case N64DD_AREA_LACKED:
		text_setting( " No enough area left.\n\n" );
		break;
	case N64DD_NOT_FOUND:
		text_setting( " Such file not found.\n\n" );
		break;
	case N64DD_ARGUMENT_ILLEGAL:
		text_setting( " Argument illegal.\n\n" );
		break;
	case N64DD_READ_ONLY_MEDIA:
		text_setting( " This media is read only.\n\n" );
		break;
	default:
		sprintf( t, " Error NO. %d.\n\n", num );
		text_setting( t );
		break;
	}
}
