#define __KEY_C

#include <ultra64.h>

#include "controller.h"
#include "main.h"
#include "menu.h"

#ifdef V2_0G
#  include <leoappli.h>
#  include "myleoapi.h"
#else
#  include <leo.h>
#endif

#include "n64dd.h"

/*****************
 *		ץȥ
 */

void key_root( void );
void key_main_menu( void );
void key_sub_menu1( void );
void key_sub_menu2( void );
void key_sub_menu3( void );
void key_sub_menu4( void );
void key_sub_menu5( void );
void key_sub_menu6( void );
void key_sub_menu7( void );

void key_finish_menu( void );
void menu_window_move_key( Menu_window * );

/*****************
 *		Хѿ
 */

static int cnt_left  = 0;
static int cnt_right = 0;
static int cnt_up    = 0;
static int cnt_down  = 0;

/*****************************************************************
 *		å()
 */
void check_key( void )
{
	switch( current_menu ){
	case MENU_NO_MENU:
		key_root();
		break;
	case MENU_MAIN_MENU:
		if ( main_menu_status == 1 )
			key_main_menu();
		break;
	case MENU_SUB_MENU1:
		if ( sub_menu1_status == 1 )
			key_sub_menu1();
		break;
	case MENU_SUB_MENU2:
		if ( sub_menu2_status == 1 )
			key_sub_menu2();
		break;
	case MENU_SUB_MENU3:
		if ( sub_menu3_status == 1 )
			key_sub_menu3();
		break;
	case MENU_SUB_MENU4:
		if ( sub_menu4_status == 1 )
			key_sub_menu4();
		break;
	case MENU_SUB_MENU5:
		if ( sub_menu5_status == 1 )
			key_sub_menu5();
		break;
	case MENU_SUB_MENU6:
		if ( sub_menu6_status == 1 )
			key_sub_menu6();
		break;
	case MENU_SUB_MENU7:
		if ( sub_menu7_status == 1 )
			key_sub_menu7();
		break;
	case MENU_FINISH_MENU:
		key_finish_menu();
		break;
	}

	/*osSyncPrintf( "cm:%d  mms:%d  sm1s:%d \n", current_menu, main_menu_status, sub_menu1_status );*/

}

/*****************************************************************
 *		(˥塼Ƥʤ)
 */
void key_root( void )
{
	/* ================ ˥塼ץ󥭡 */
	if ( press_down & CONT_A ){
		main_menu_status = MENU_OPEN_CNT;
		current_menu = MENU_MAIN_MENU;
	}

	/* ================ ̥ɥ */
	if ( press_down & (CONT_L | CONT_R | CONT_B) ){
		output_menu_status = MENU_OPEN_CNT;
		current_menu = MENU_FINISH_MENU;
	}

	/* ================ إå */
	if ( press_down & CONT_START ){
		LEOCmd		cmdBlock;
		LeoSpdlMotor( &cmdBlock, LEO_MOTOR_SLEEP, &diskQ );
	}

#if 0
	/* ================ */
	if ( button & CONT_D ){
		osSyncPrintf( "%d\n", n64dd_check_insert() );
	}
#endif


	if ( button & CONT_D ){
		osSyncPrintf( "Set RTC\n" );
		if ( n64dd_set_RTC_BCD( 0x97, 0x05, 0x07, 0x10, 0x7, 0x0 ) < 0 )
			osSyncPrintf( "ERROR!! no %d\n", n64dd_error_no );
	}

	if ( button & CONT_E ){
		int a, b, c,d,e,f;

		d = 899;
		n64dd_get_RTC( &a, &b, &c, NULL, &e, &f );
		osSyncPrintf( "%d %d %d %d %d %d \n", a,b,c,d,e,f );
	}

}

/*****************************************************************
 *		å(ᥤ˥塼)
 */
void key_main_menu( void )
{
	/* ================ ɥư */
	menu_window_move_key( &main_menu_window );

	/* ================ 򥭡 */
	if ( press_down & CONT_UP ){
		exec_command --;
	}
	if ( press_down & CONT_DOWN ){
		exec_command ++;
	}

	if ( exec_command < 1 ) exec_command = 1;
	if ( exec_command > EXEC_LAST ) exec_command = EXEC_LAST;


	/* ================ ޥȯư */
	if ( press_down & CONT_A ){
		switch( exec_command ){
		case EXEC_SAVE:
		case EXEC_LOAD:
		case EXEC_DELETE:
			sub_menu1_status = MENU_OPEN_CNT;
			current_menu = MENU_SUB_MENU1;
			break;
		case EXEC_FORMAT:
			sub_menu2_status = MENU_OPEN_CNT;
			current_menu = MENU_SUB_MENU2;
			command_confirm = 1;
			break;
		case EXEC_LS:
		case EXEC_DF:
			wait_menu_status = MENU_OPEN_CNT;
			current_menu = MENU_WAIT_MENU;
			exec_on = 1;
			break;
		case EXEC_PICT:
			sub_menu4_status = MENU_OPEN_CNT;
			current_menu = MENU_SUB_MENU4;
			break;
		case EXEC_FAT:
			sub_menu5_status = MENU_OPEN_CNT;
			current_menu = MENU_SUB_MENU5;
			fat_address = show_fat_address;
			break;
		case EXEC_VFAT:
			sub_menu5_status = MENU_OPEN_CNT;
			current_menu = MENU_SUB_MENU5;
			fat_address = vfat_address;
			break;
		}
	}

	/* ================ ˥塼 */
	if ( press_down & CONT_B ){
		main_menu_status = MENU_CLOSE_CNT;
	current_menu = MENU_NO_MENU;
	}
}

/*****************************************************************
 *		֥˥塼( ե )
 */
void key_sub_menu1( void ){

	/* ================ ɥư */
	menu_window_move_key( &sub_menu1_window );

	/* ================ 򥭡 */
	if ( press_down & CONT_UP ){
		selected_file_num--;
	}
	if ( press_down & CONT_DOWN ){
		selected_file_num++;
	}

	if ( selected_file_num < 0 ){
		selected_file_num = 0;
		if ( shown_file_num > 0 ) shown_file_num --;
	}
	if ( selected_file_num > 9 ){
		selected_file_num = 9;
		if ( file_name_string[ shown_file_num + selected_file_num + 1 ][0] ) shown_file_num ++;
	}

	/* ================ ޥȯư */
	if ( press_down & CONT_A ){
		switch( exec_command ){
		case EXEC_SAVE:
		case EXEC_LOAD:
			sub_menu3_status = MENU_OPEN_CNT;
			current_menu = MENU_SUB_MENU3;
			break;
		case EXEC_DELETE:
			sub_menu2_status = MENU_OPEN_CNT;	/* ǧ*/
			current_menu = MENU_SUB_MENU2;
			command_confirm = 1;
			break;
		}
	}

	/* ================ ˥塼 */
	if ( press_down & CONT_B ){
		sub_menu1_status = MENU_CLOSE_CNT;
		current_menu = MENU_MAIN_MENU;		/* ᥤ˥塼 */
	}
}


/*****************************************************************
 *		֥˥塼(ǧ)
 */
void key_sub_menu2( void )
{
	int quit_flag = 0;

	/* ================ ɥư */
	menu_window_move_key( &sub_menu2_window );

	/* ================ 򥭡 */
	if ( press_down & CONT_LEFT ){
		command_confirm = 0;
	}
	if ( press_down & CONT_RIGHT ){
		command_confirm = 1;
	}

	/* ================ ޥȯư */
	if ( press_down & CONT_A ){
		/* ==== YES */
		if ( command_confirm == 0 ){
			wait_menu_status = MENU_OPEN_CNT;
			current_menu = MENU_WAIT_MENU;

			switch( exec_command ){
			case EXEC_FORMAT:
			case EXEC_DELETE:
				break;
			}
			exec_on = 1;
		}
		/* ==== NO */
		else{
			quit_flag = 1;
		}
	}

	/* ================ ˥塼 */
	if ( (press_down & CONT_B) || quit_flag ){
		sub_menu2_status = MENU_CLOSE_CNT;
		switch( exec_command ){
		case EXEC_FORMAT:
			current_menu = MENU_MAIN_MENU;		/* ᥤ˥塼 */
			break;
		case EXEC_DELETE:
			current_menu = MENU_SUB_MENU1;		/* ե˥塼 */
			break;
		}
	}
}

/*****************************************************************
 *		֥˥塼(ե륵)
 */
void key_sub_menu3( void )
{
	int i;

	/* ================ ɥư */
	menu_window_move_key( &sub_menu3_window );

	/* ================ ѹ */
	if ( (i = button & CONT_LEFT) || (cnt_left *= i) ){
		if ( (cnt_left++==0) || (cnt_left>10) ){
			i = 1;
			if ( cnt_left > 30 ) i = 4;
			if ( cnt_left > 50 ) i = 64;
			file_size -= i;
		}
	}

	if ( (i = button & CONT_RIGHT) || (cnt_right *= i) ){
		if ( (cnt_right++==0) || (cnt_right>10) ){
			i = 1;
			if ( cnt_right > 30 ) i = 4;
			if ( cnt_right > 50 ) i = 64;
			file_size += i;
		}
	}


	if ( (i = button & CONT_UP ) || (cnt_up *= i) ){
		if ( (cnt_up++==0) || (cnt_up>10) ){
			i = 0x1000;
			if ( cnt_up > 30 ) i = 0x4000;
			if ( cnt_up > 50 ) i = 0x20000;
			file_size += i;
			file_size &= 0xffff000;
		}
	}

	if ( button & CONT_DOWN ){
		if ( (cnt_down==0) || (cnt_down>10) ){
			i = 0x1000;
			if ( cnt_down > 30 ) i = 0x4000;
			if ( cnt_down > 50 ) i = 0x20000;
			if ( file_size <= i )
				file_size = 0;
			else{
				file_size -= i;
				file_size &= 0xffff000;
			}
		}
		cnt_down++;
	}
	else
		cnt_down = 0;

	if ( file_size < 0 ) file_size = 0;
	if ( file_size > 0x1000000 ) file_size = 0x1000000;

	/* ================ ޥȯư */
	if ( press_down & CONT_A ){
		/* ޥɼ¹ */
		wait_menu_status = MENU_OPEN_CNT;
		current_menu = MENU_WAIT_MENU;
		switch ( exec_command ){
		case EXEC_SAVE:
		case EXEC_LOAD:
			break;
		}
		exec_on = 1;
	}

	/* ================ ˥塼 */
	if ( press_down & CONT_B ){
		sub_menu3_status = MENU_CLOSE_CNT;
		current_menu = MENU_SUB_MENU1;
	}
}

/*****************************************************************
 *		֥˥塼( ɻ )
 */
void key_sub_menu4( void ){

	/* ================ ɥư */
	menu_window_move_key( &sub_menu4_window );

	/* ================ 򥭡 */
	if ( press_down & CONT_UP ){
		selected_pict_num--;
	}
	if ( press_down & CONT_DOWN ){
		selected_pict_num++;
	}

	if ( selected_pict_num < 0 ) selected_pict_num = 0;
	if ( selected_pict_num > 9 ) selected_pict_num = 9;

	/* ================ ޥȯư */
	if ( press_down & CONT_A ){
		wait_menu_status = MENU_OPEN_CNT;
		current_menu = MENU_WAIT_MENU;
		exec_on = 1;
	}

	/* ================ ˥塼 */
	if ( press_down & CONT_B ){
		sub_menu4_status = MENU_CLOSE_CNT;
		current_menu = MENU_MAIN_MENU;		/* ᥤ˥塼 */
	}
}

/*****************************************************************
 *		֥˥塼(FAT ɥ쥹)
 */
void key_sub_menu5( void )
{
	int i;

	/* ================ ɥư */
	menu_window_move_key( &sub_menu5_window );

	/* ================ ѹ */
	if ( (i = button & CONT_LEFT) || (cnt_left *= i) ){
		if ( (cnt_left++==0) || (cnt_left>10) ){
			i = 0x10;
			if ( cnt_left > 30 ) i = 0x40;
			if ( cnt_left > 50 ) i = 0x100;
			fat_address -= i;
		}
	}

	if ( (i = button & CONT_RIGHT) || (cnt_right *= i) ){
		if ( (cnt_right++==0) || (cnt_right>10) ){
			i = 0x10;
			if ( cnt_right > 30 ) i = 0x40;
			if ( cnt_right > 50 ) i = 0x100;
			fat_address += i;
		}
	}


	if ( (i = button & CONT_UP ) || (cnt_up *= i) ){
		if ( (cnt_up++==0) || (cnt_up>10) ){
			i = 0x1000;
			if ( cnt_up > 30 ) i = 0x4000;
			if ( cnt_up > 50 ) i = 0x10000;
			fat_address += i;
		}
	}

	if ( button & CONT_DOWN ){
		if ( (cnt_down==0) || (cnt_down>10) ){
			i = 0x1000;
			if ( cnt_down > 30 ) i = 0x4000;
			if ( cnt_down > 50 ) i = 0x10000;
			if ( fat_address <= i )
				fat_address = 0;
			else{
				fat_address -= i;
			}
		}
		cnt_down++;
	}
	else
		cnt_down = 0;

	if ( fat_address < 0 ) fat_address = 0;
	if ( fat_address > 0x4d10 ) fat_address = 0x4d10;

	/* ================ ޥȯư */
	if ( press_down & CONT_A ){
		/* ޥɼ¹ */
		/*wait_menu_status = MENU_OPEN_CNT;
		current_menu = MENU_WAIT_MENU;
		exec_on = 1;*/
		switch ( exec_command ){
		case EXEC_FAT:
			sub_menu6_status = MENU_OPEN_CNT;
			current_menu = MENU_SUB_MENU6;
			show_fat_address = fat_address;
			break;
		case EXEC_VFAT:
			sub_menu7_status = MENU_OPEN_CNT;
			current_menu = MENU_SUB_MENU7;
			vfat_address = fat_address;
			break;
		}
	}

	/* ================ ˥塼 */
	if ( press_down & CONT_B ){
		sub_menu5_status = MENU_CLOSE_CNT;
		current_menu = MENU_MAIN_MENU;
	}
}

/*****************************************************************
 *		֥˥塼(FAT ɽ)
 */
void key_sub_menu6( void )
{
	int i;

	/* ================ ɥư */
	menu_window_move_key( &sub_menu6_window );

	/* ================ ¹Է̥ɥ */
	if ( (i = button & CONT_UP ) || (cnt_up *= i) ){
		if ( (cnt_up++==0) || (cnt_up>10) ){
			i = 0x10;
			if ( cnt_up > 20 ) i = 0x40;
			if ( cnt_up > 40 ) i = 0x100;
			show_fat_address -= i;
		}
	}

	if ( (i = button & CONT_DOWN ) || (cnt_down *= i) ){
		if ( (cnt_down++==0) || (cnt_down>10) ){
			i = 0x10;
			if ( cnt_down > 20 ) i = 0x40;
			if ( cnt_down > 40 ) i = 0x100;
			show_fat_address += i;
		}
	}

	if ( show_fat_address < 0 ) show_fat_address = 0;
	if ( show_fat_address > 0x4d10 ) show_fat_address = 0x4d10;

	/* ================ ˥塼 */
	if ( press_down & (CONT_B | CONT_A) ){
		sub_menu6_status = MENU_CLOSE_CNT;
		current_menu = MENU_SUB_MENU5;
	}
}

/*****************************************************************
 *		֥˥塼(visible FAT ɽ)
 */
void key_sub_menu7( void )
{
	int i;

	/* ================ ɥư */
	menu_window_move_key( &sub_menu6_window );

	/* ================ ¹Է̥ɥ */
	if ( (i = button & CONT_UP ) || (cnt_up *= i) ){
		if ( (cnt_up++==0) || (cnt_up>10) ){
			i = 0x10;
			if ( cnt_up > 20 ) i = 0x40;
			if ( cnt_up > 40 ) i = 0x100;
			vfat_address -= i;
		}
	}

	if ( (i = button & CONT_DOWN ) || (cnt_down *= i) ){
		if ( (cnt_down++==0) || (cnt_down>10) ){
			i = 0x10;
			if ( cnt_down > 20 ) i = 0x40;
			if ( cnt_down > 40 ) i = 0x100;
			vfat_address += i;
		}
	}

	if ( vfat_address < 0 ) vfat_address = 0;
	if ( vfat_address > n64dd_cap.endLBA - n64dd_cap.startLBA-256 ) vfat_address = (n64dd_cap.endLBA - n64dd_cap.startLBA - 256 + 16) & 0xfff0;

	/* ================ ˥塼 */
	if ( press_down & (CONT_B | CONT_A) ){
		sub_menu7_status = MENU_CLOSE_CNT;
		current_menu = MENU_SUB_MENU5;
	}
}

/*****************************************************************
 *		ޥɽλɥ
 */
void key_finish_menu( void )
{
	int i;

	/* ================ ɥư */
	menu_window_move_key( &output_menu_window );

	/* ================ ¹Է̥ɥ */
	/*osSyncPrintf( "%d  %d    (%d)\n", button, cnt_up, text_start_line );*/
	if ( (i = button & CONT_UP ) || (cnt_up *= i) ){
		if ( (cnt_up++==0) || (cnt_up>10) ){
			i = 1;
			if ( cnt_up > 10 ) i = 2;
			if ( cnt_up > 20 ) i = 4;
			text_start_line -= i;
		}
	}

	if ( (i = button & CONT_DOWN ) || (cnt_down *= i) ){
		if ( (cnt_down++==0) || (cnt_down>10) ){
			i = 1;
			if ( cnt_down > 10 ) i = 2;
			if ( cnt_down > 20 ) i = 4;
			text_start_line += i;
		}
	}

	if ( text_start_line < 0 ) text_start_line = 0;
	if ( text_start_line > TEXT_Y-TEXT_VIEW_Y ) text_start_line = TEXT_Y - TEXT_VIEW_Y;


	/* ================ ޥɽλ */
	if ( press_down & (CONT_A | CONT_B | CONT_L | CONT_R) ){
		clean_windows();
		current_menu = MENU_NO_MENU;
		exec_on = 0;
		text_start_line = TEXT_Y - TEXT_VIEW_Y;
	}
}

/*****************************************************************
 *		ɥư⥸塼
 */
void menu_window_move_key( Menu_window *mw )
{
	if ( button & CONT_E ){
		mw->y --;
	}
	if ( button & CONT_D ){
		mw->y ++;
	}
	if ( button & CONT_C ){
		mw->x --;
	}
	if ( button & CONT_F ){
		mw->x ++;
	}

	if ( mw->y < 0 ) mw->y = 0;
	if ( mw->y + mw->dy >34 ) mw->y = 34 - mw->dy;
	if ( mw->x < 0 ) mw->x = 0;
	if ( mw->x + mw->dx >63 ) mw->x = 63 - mw->dx;
}
