/*****************************************************************
 * 		File:  main.c
 *****************************************************************/
#define DISK

/*****************************************************************
 *	󥯥롼
 */
#include <ultra64.h>
#include <PR/ramrom.h>
#include <assert.h>

#ifdef V2_0G
#  include <leoappli.h>
#  include "myleoapi.h"
#else
#  include <leo.h>
#endif

#include "define.h"
#include "controller.h"

#include "rsp_cfb.h"
#include "cfb.h"
#include "n64dd.h"
#include "nsfont.h"
#include "cg_area.h"
#include "static.h"
#include "key.h"
#include "command1.h"
#include "command2.h"
#include "menu.h"
#include "main.h"
#include "picture_buf.h"


/*****************************************************************
 *		ԥޥǥХå
 */
#ifdef V2_0G
void	ptstart( void );
#endif

/*****************************************************************
 *		ץȥ
 */

static void     idle(void *);
static void     mainproc(void *);
void draw_picture( void );

/* ================ RDRAM Υ */
extern char     _cg_areaSegmentEnd[];
extern char     _cg_areaSegmentTextStart[];
extern char     _cg_areaSegmentTextEnd[];

/* ================ 64DD Υ */
extern char		_codeSegmentDiskStart[],
               	_codeSegmentDiskEnd[];
extern char	   	_staticSegmentDiskStart[],
               	_staticSegmentDiskEnd[];
extern char	   	_mrdoSegmentDiskStart[],
               	_mrdoSegmentDiskEnd[];
extern char	   	_jozetSegmentDiskStart[],
               	_jozetSegmentDiskEnd[];
extern char	   	_sobautiSegmentDiskStart[],
               	_sobautiSegmentDiskEnd[];
extern char	   	_kekkanSegmentDiskStart[],
               	_kekkanSegmentDiskEnd[];
extern char	   	_kawagutiSegmentDiskStart[],
               	_kawagutiSegmentDiskEnd[];

/* ================ åɥå */
u64             bootStack[STACKSIZE / sizeof(u64)];

static OSThread idleThread;
static u64      idleThreadStack[STACKSIZE / sizeof(u64)];

static OSThread mainThread;
static u64      mainThreadStack[STACKSIZE / sizeof(u64)];

/* ================ PI ޥ͡ */
#define NUM_PI_MSGS     8

static OSMesg   		PiMessages[NUM_PI_MSGS];
static OSMesgQueue 		PiMessageQ;
static OSMesgQueue      dma_msg_Q;
static OSMesg           dma_msg_buffer;

/* ================ å塼 */
OSMesgQueue     rspMessageQ, rdpMessageQ, retraceMessageQ;
OSMesg          rspMessageBuf, rdpMessageBuf, retraceMessageBuf;

/* ================ ʥߥåǡ */
Dynamic         dynamic;

/* ================ һ */
OSTask          tlist =
{
	M_GFXTASK,					/* task type  */
	OS_TASK_DP_WAIT,			/* task flags */
	NULL,						/* boot ucode pointer (fill in later) */
	0,							/* boot ucode size (fill in later) */
	NULL,						/* task ucode pointer (fill in later) */
	SP_UCODE_SIZE,				/* task ucode size */
	NULL,						/* task ucode data pointer (fill in later) */
	SP_UCODE_DATA_SIZE,			/* task ucode data size */
	&(dram_stack[0]),			/* task dram stack pointer */
	SP_DRAM_STACK_SIZE8,		/* task dram stack size */
	NULL,						/* task output buffer ptr (not always used) */
	NULL,						/* task output buffer size ptr */
	NULL,						/* task data pointer (fill in later) */
	0,							/* task data size (fill in later) */
	NULL,						/* task yield buffer ptr (not used here) */
	0							/* task yield buffer size (not used here) */
};

Gfx            *glistp;			/* global for test case procs */


/* ================ Хѿ */
int				frame = 0;
int				draw_buffer = 0;
int      		PrintEn = 0;
char			filechar = '0';

s32				testsize[] = { 0x10, 0x1000, 0x10000, 0x1a000, 0x1c000, 0x1e000,
							   0x20000, 0x21000, 0x22000,  0x23000, 0x100000, 0x400000, 0x1000000, 0 };
int				testsize_p = 0;

char			text[ TEXT_Y ][ TEXT_X_SAVE ];	/* X  Y ν! */
char			text_sp_area[ TEXT_X_SAVE * TEXT_VIEW_Y ];
int				curX = 0;	/* ʸǼݥ */
int				curY = 0;
int				curX_cnt = 0;	/* ʸ */

int				text_start_line = TEXT_Y - TEXT_VIEW_Y;

int				exec_command = 1;		/* ¹Ԥ륳ޥ */
int				exec_on = 0;			/* ¹ԥե饰( 0Ǽ¹ ) */

char			command_string[][10] = { " ", "SAVE", "LOAD", "DELETE", "LIST", "DISKINFO", "MEDIAINIT", "PICTURE", "FAT", "VFAT", "\0" };
int				command_option_num[] = {   0,     2,    2,     1,         0,      0,           0,            0,       0,     0,     0    };
int				command_option_index = 0;
char			file_name_string[][32] = { "file0", "file1", "file2", "file3", "file4", "A@#f99B@-C",
										   "test", "TEST", "test.dat", "test:970201", "test:Feb/1",
										   "test(01)", "test(02)", "test(%A)", "test_99", "(@@@B@R@a@b@c@d@e)",
										   "test 12:34",  "P>P\\,^$%&<#P",   0 };
char			pict_name_string[][32] = { "* clear *", "Mr.Do", "Jozet", "Sobauti", "Kekkan", "Tired", "PICT6", "PICT7", "PICT8", "PICT9", 0 };

int				tmp_val;



/****************************************************************
*		֡
*/
void
boot(void)
{
	/* ================ OS */
	osInitialize();

	/* ================ partner-N64  */
#ifdef V2_0G
	ptstart();
#endif

	/* ================ ɥ륹åɤ */
	osCreateThread( &idleThread, 1, idle, (void *) 0,idleThreadStack + STACKSIZE / sizeof(u64), 10 );
	osStartThread( &idleThread);
}

/*****************************************************************
 *		ɥ륹å
 */
static void idle(void *arg)
{
	/* ================ video ν */
	osCreateViManager( OS_PRIORITY_VIMGR );
	osViSetMode( &osViModeTable[ OS_VI_NTSC_LAN1 ] );
	osViSetSpecialFeatures( OS_VI_DITHER_FILTER_ON | OS_VI_DIVOT_OFF | OS_VI_GAMMA_ON );
	osViBlack( TRUE );

	/* ================ PI ޥ͡㥹 */
	osCreatePiManager( (OSPri)OS_PRIORITY_PIMGR, &PiMessageQ, PiMessages, NUM_PI_MSGS );

	/* ================ ᥤ󥹥åɺ */
	osCreateThread( &mainThread, 3, mainproc, arg, mainThreadStack + STACKSIZE / sizeof( u64 ), 10 );
	osStartThread( &mainThread );

	/* ================ ɥ륹åɤˤʤ */
	osSetThreadPri( 0, 0 );
	for (;;) ;
}

/*****************************************************************
 * 		ᥤ롼
 */
static void mainproc( void *arg )
{
	OSTask         *tlistp;
	Dynamic        *dynamicp;
	char           *staticSegment;
	LEOCmd			cmdBlock;
	static int 		theta;

	/* ================ å塼 */
	/* ǥѥ塼 */
	n64dd_createQ();

	/* DMA å塼 */
    osCreateMesgQueue( &dma_msg_Q, &dma_msg_buffer, 1 );

	osCreateMesgQueue( &rspMessageQ, &rspMessageBuf, 1 );
	osSetEventMesg( OS_EVENT_SP, &rspMessageQ, NULL );

	osCreateMesgQueue( &rdpMessageQ, &rdpMessageBuf, 1 );
	osSetEventMesg( OS_EVENT_DP, &rdpMessageQ, NULL );

	osCreateMesgQueue( &retraceMessageQ, &retraceMessageBuf, 1 );
	osViSetEvent( &retraceMessageQ, NULL, 1 );

	/* ================ ǥޥ͡ */
	if ( n64dd_create_manager() == 0 ){
		staticSegment = _cg_areaSegmentEnd;					/* code/data Ȥθ static Ȥ򤯤äĤ */

		/*osSyncPrintf(  "%x  %x   \n", (u32)_staticSegmentDiskStart, (u32)_staticSegmentDiskEnd );*/

		for(;;){
			LeoReadWrite( &cmdBlock, OS_READ,
						  (u32)_staticSegmentDiskStart, staticSegment,
						  (u32)_staticSegmentDiskEnd - (u32)_staticSegmentDiskStart,
						  &diskQ );
			  
			osRecvMesg( &diskQ, NULL, OS_MESG_BLOCK );
			
			n64dd_error_no = GET_ERROR( cmdBlock );
			if ( n64dd_error_no == 0 )    break;

			osSyncPrintf("error = 0x%x\n", n64dd_error_no );

			if ( n64dd_error_no == LEO_ERROR_MEDIUM_MAY_HAVE_CHANGED ) continue;
			osSyncPrintf( "Fatal error: read segment\n" );
			for(;;);
		}
	}
	else{
		osSyncPrintf( "***** FAIL TO INITIALIZE\n" );
		for(;;);
	}

	/* ================ ǥϢѿ */
	n64dd_newdisk();

	/* ================ ȥ */
	initControllers();

	/* ================================================================ */
	/*  */
	{
		int i;

		clear_text();
		for( i=0; i<320*240; i++ ) cg_data[ i ] = 0x0;
	}

	/* ================================================================ ᥤ롼 */
	while (1) {

		/* ================ ȥ */
		osContStartReadData( &controllerMsgQ );
		ReadController();

		/* ================ ǥץ쥤ꥹȤۤ뤿Υݥ */
		tlistp = &tlist;
		dynamicp = &dynamic;

		guOrtho( &dynamicp->projection,             -(float)SCREEN_WD/2.0, (float)SCREEN_WD/2.0,
                                                    -(float)SCREEN_HT/2.0, (float)SCREEN_HT/2.0,
                                                    1.0, 10.0, 1.0 );
		guRotate(&dynamicp->modeling, theta, 0.0F, 0.0F, 1.0F);

		glistp = dynamicp->glist;

		/* ================ RCP ˥Ȱ֤򶵤 */
		gSPSegment( glistp++, 0, 0x0 );												/* ʪɥ쥹 */
		gSPSegment( glistp++, STATIC_SEGMENT, OS_K0_TO_PHYSICAL( staticSegment ) );
		gSPSegment( glistp++, CFB_SEGMENT, OS_K0_TO_PHYSICAL( cfb[ draw_buffer ] ) );
		gSPSegment( glistp++, PICTURE_SEGMENT, OS_K0_TO_PHYSICAL( picture_buf ) );

		/* ================ RDP ơȽ */
		gSPDisplayList( glistp++, rdpinit_dl );

		/* ================ RSP ơȽ */
		gSPDisplayList( glistp++, rspinit_dl );

		/* ================ 顼ե졼Хåեꥢ */
		gSPDisplayList( glistp++, clearcfb_dl );

		/* ================ ƥȽ */
		text_init();

		/* ================ å */
		check_key();

		/* ================ ɽ */
		if ( ( button & CONT_G ) == 0 )	draw_picture();

		if ( ( button & CONT_START ) == 0 ){
			/* ==== ˥塼 */
			draw_menu();

			/* ==== Хޥɼ¹ */
			if ( exec_on )	do_command();
		}

		/* ================ ƥȽλ */
		text_end();

		/* ================ */
		gDPFullSync( glistp++ );
		gSPEndDisplayList( glistp++ );
	
		assert((glistp - dynamicp->glist) < GLIST_LEN);

		/* ================ եåۤ */
		tlistp->t.ucode_boot = (u64 *) rspbootTextStart;
		tlistp->t.ucode_boot_size = (u32) rspbootTextEnd - (u32) rspbootTextStart;

		/* ================ RSP  XBUS Ȥä RDP ˽Ϥ */
		tlistp->t.ucode = (u64 *) gspFast3DTextStart;
		tlistp->t.ucode_data = (u64 *) gspFast3DDataStart;

		/* ================ ǥץ쥤ꥹȽ */
		tlistp->t.data_ptr = (u64 *) dynamicp->glist;
		tlistp->t.data_size = (u32) ((glistp - dynamicp->glist) * sizeof(Gfx));

		/* ================ å񤭹 */
		osWritebackDCache(&dynamic, sizeof(dynamic));

		/* ================ RSP  */
		osSpTaskStart(tlistp);

		/* ================ SP ,DP λԤ */
		(void) osRecvMesg(&rspMessageQ, NULL, OS_MESG_BLOCK);
		(void) osRecvMesg(&rdpMessageQ, NULL, OS_MESG_BLOCK);

		/* ================ åץå */
		osViSwapBuffer(cfb[draw_buffer]);

		/* ================ Ťȥ졼塼ˤʤȤǧ */
		/* 					(塼οϣȲ)		 */
		if (MQ_IS_FULL(&retraceMessageQ))	(void) osRecvMesg(&retraceMessageQ, NULL, OS_MESG_BLOCK);

		/* ================ ХåեåפΤ˿ľȥ졼Ԥ */
		(void) osRecvMesg(&retraceMessageQ, NULL, OS_MESG_BLOCK);
		draw_buffer ^= 1;

		/* ================ ֥å */
		{
			static int flag=0;
			if (flag){ osViBlack( FALSE); }
			flag = 1;
		}

		theta += 5; if ( theta > 360 ) theta -= 360;
		frame++;
	}

}

/*****************************************************************
 *		Хåγ
 */
void draw_picture( void )
{
	int x, y;

	gSPDisplayList( glistp++, prepare_rectangle_dl );


	for ( y=0; y<7; y++ ){
		for ( x=0; x<5; x++ ){
			gDPPipeSync( glistp++ );
		    gDPLoadTextureTile( glistp++,
								cg_data, G_IM_FMT_RGBA, G_IM_SIZ_16b, 320, 240,
								(x*64), (y*32), (x*64+63), (y*32+31),
								0,	G_TX_WRAP , G_TX_WRAP,
								6, 5, G_TX_NOLOD, G_TX_NOLOD );

			gSPTextureRectangle( glistp++, 
								 (x*64)<<2, (y*32)<<2, (x*64+64)<<2, (y*32+32)<<2,
								 G_TX_RENDERTILE, 0, 0, 1<<10, 1<<10 );
		}
	}
	y = 7;
	{
		for ( x=0; x<5; x++ ){
			gDPPipeSync( glistp++ );
		    gDPLoadTextureTile( glistp++,
								cg_data, G_IM_FMT_RGBA, G_IM_SIZ_16b, 320, 240,
								(x*64), (y*32), (x*64+63), (y*32+15),
								0,	G_TX_WRAP , G_TX_WRAP,
								6, 4, G_TX_NOLOD, G_TX_NOLOD );

			gSPTextureRectangle( glistp++, 
								 (x*64)<<2, (y*32)<<2, (x*64+64)<<2, (y*32+16)<<2,
								 G_TX_RENDERTILE, 0, 0, 1<<10, 1<<10 );
		}
	}
}

/*****************************************************************
 *		ƥɽ
 */
void draw_text( int dummy )
{
	int		x, y;
	char	*p;
	
	text_size( TEXT_X, TEXT_VIEW_Y );

	text_pos( output_menu_window.x+1, output_menu_window.y+1 );
	text_cur( 0, 0 );
	if ( text_start_line == TEXT_Y - TEXT_VIEW_Y )
		text_color( 255, 255, 255 );
	else if ( text_start_line == 0 ){
		text_color( 255, 100, 100 );
		text_color_change( 0 );
	}
	else{
		text_color( 0, 255, 255 );
		text_color_change( 0 );
	}

	/* ==== font sprite ʸѴ */
	p = text_sp_area;
	for( y = text_start_line;  y < text_start_line + TEXT_VIEW_Y;   y++ ){
		for( x=0; x<TEXT_X_SAVE; x++ ){
			if ( (text[y][x] == '\0') || (text[y][x] == '\n' ) ){
				*p++ = '\n';
				break;
			}
			*p++ = text[y][x];
		}
	}
	*p = '\0';

	/* ==== ɽ */
	text_print_pre( &glistp, text_sp_area );
	text_color_change( 1 );
}

/*****************************************************************
 *		ƥȥꥢ
 */
void clear_text( void )
{
	int		y;

	for( y=0; y<TEXT_Y; y++ ){
		text[y][0] = '\0';
	}
	
	curX = 0;
	curY = TEXT_Y - 1;
	curX_cnt = 0;
}

/****************************************************************
 *		ʸɽ
 */
void text_setting( char *st )
{
	int		i;

	for( i=0; ; i++ ){

		if ( st[i] == '\0' ){
			text[curY][curX] = '\0';
			break;
		}

		if ( st[i] == '\n' ){
			text[curY][curX] = '\0';
			if ( curY >= TEXT_Y-1 ){
				text_scroll();
				curY = TEXT_Y-1;
			}
			else
				curY ++;
			curX = 0;
			curX_cnt = 0;
			continue;
		}
		
		if ( st[i] == '@' ){
			switch( st[i+1] ){
			case '#':
			case '$':
				text[curY][curX] = st[i];
				text[curY][curX+1] = st[i+1];
				text[curY][curX+2] = st[i+2];
				text[curY][curX+3] = st[i+3];
				text[curY][curX+4] = st[i+4];
				curX += 5;
				i += 4;
				break;
			default:
				text[curY][curX] = st[i];
				text[curY][curX+1] = st[i+1];
				switch( st[i+1] ){
				case '-':
					break;
				case '<':
					if ( curX_cnt > 0 ) curX_cnt --;
					break;
				default:
					curX_cnt++;
				}
				curX += 2;
				i ++;
			}
		}
		else{
			text[curY][curX] = st[i];
			curX++;
			curX_cnt++;
		}

		/* üޤǤȽ */
		if( curX_cnt >= TEXT_X-1 ){
			text[curY][curX] = '\0';
			if ( curY >= TEXT_Y-1 ){
				text_scroll();
				curY = TEXT_Y-1;
			}
			else
				curY ++;
			curX = 0;
			curX_cnt = 0;
			continue;
		}
	}
}

/****************************************************************
 *		ʸ󥨥ꥢ
 */
void text_scroll( void )
{
	int		x, y;
	
	for( y=0; y< TEXT_Y-1; y++ ){
		for( x=0; x< TEXT_X_SAVE; x++ ){
			text[y][x] = text[y+1][x];
		}
	}
}

/****************************************************************
 *		߹Ժ
 */
void text_del_line( void )
{
	text[ curY ][0] = '\0';
	curX = 0;
	curX_cnt = 0;
}


/*****************************************************************
 *		ʸ󥳥ԡ
 */
void strcpy( char *dest, char *src )
{
	char *s = src;
	char *d = dest;
	
	if ( ( s == NULL ) || ( d == NULL ) ) return;
	while( *s ){
		*d++ = *s++;
	}
	*d = '\0';
}

void strncpy( char *dest, char *src, int len )
{
	char *s = src;
	char *d = dest;
	
	if ( ( s == NULL ) || ( d == NULL ) ) return;
	while( len && *s ){
		*d++ = *s++;
		len--;
	}
	*d = '\0';
}

/*****************************************************************
 *		ʸϢ
 */
void strcat( char *dest, char *src )
{
	char *s = src;
	char *d = dest;
	
	if ( s == NULL ) return;

	while( *d ) d++;
	while( *s ){
		*d++ = *s++;
	}
	*d = '\0';
}

/*****************************************************************
 *		ʸʸĴ
 */
void strlenset( char *src, int len )
{
	int		flag=0;
	
	while( len ){
		if ( *src == '\0' ) flag = 1;
		if ( flag ) *src = ' ';
		src++;
		len--;
	}

	*src = '\0';
}

/*****************************************************************
 *	桼ƥƥ롼
 *		rom  ram ؤž롼
 */
void rom_copy( const char *src,   const char *dest,   const int len )
{
	OSIoMesg    dma_io_msg_buffer;
	OSMesg              dummy_msg;

	osInvalDCache( (void *)dest, (s32)len );
	osPiStartDma( &dma_io_msg_buffer,  OS_MESG_PRI_NORMAL,  OS_READ,  (u32)src,  (void *)dest,  (u32)len,  &dma_msg_Q );
	osRecvMesg( &dma_msg_Q, &dummy_msg, OS_MESG_BLOCK );
}

/*****************************************************************
 *	 disk  RAM ž롣
 *		ĹꤷƤΤ˽λȤ񤯤ΤϾĹȤꤢ
 */
void pict_trans( int num )
{
	switch ( num ){
	case 1:
		pict_trans_sub( (int)_mrdoSegmentDiskStart, (int)_mrdoSegmentDiskEnd, 0x25800, (u32*)picture_buf );
		break;
	case 2:
		pict_trans_sub( (int)_jozetSegmentDiskStart, (int)_jozetSegmentDiskEnd, 0x25800, (u32*)picture_buf );
		break;
	case 3:
		pict_trans_sub( (int)_sobautiSegmentDiskStart, (int)_sobautiSegmentDiskEnd, 0x25800, (u32*)picture_buf );
		break;
	case 4:
		pict_trans_sub( (int)_kekkanSegmentDiskStart, (int)_kekkanSegmentDiskEnd, 0x25800, (u32*)picture_buf );
		break;
	case 5:
		pict_trans_sub( (int)_kawagutiSegmentDiskStart, (int)_kawagutiSegmentDiskEnd, 0x25800, (u32*)picture_buf );
		break;
	}
}

/*****************************************************************
 *	Υ֥롼
 */
void pict_trans_sub( int start_seg, int end_seg, int len, u32* dist )
{
	LEOCmd		cmdBlock;
	int 		ws, se, se0;
	s32 		leftbyte, sumbyte, sumbyte0, *sdma;
	u32			*dist0 = dist;			/* եɤ߹ */

	ws = start_seg;
	se = end_seg - start_seg;
	leftbyte = len;

	/* Τޤɤ鲿ХȤˤʤ롩 */
	LeoLBAToByte( ws, se, &sumbyte );

	/* ŪХȰʲʤ餳ΤޤɤOK */
	if ( leftbyte >= sumbyte ){
		LeoReadWrite( &cmdBlock, OS_READ, ws, dist0, se, &diskQ );
		osRecvMesg( &diskQ, NULL, OS_MESG_BLOCK );

		n64dd_error_no = GET_ERROR( cmdBlock );
		if ( n64dd_error_no ) return;
	}
	/* ΤޤɤŪХȤĶ */
	else{
		/* Ⱦü֥åõ */
		for( se0=1; se0<=se; se0++ ){
			LeoLBAToByte( ws, se0, &sumbyte0 );
			if ( sumbyte0 >= leftbyte ) break;		/* ĤХȤĶ(ޤƱ) */
		}

		if ( se0 >= 2 ){								/* ݡɤǤ֥å */
			se0--;
			LeoLBAToByte( ws, se0, &sumbyte0 );
			LeoReadWrite( &cmdBlock, OS_READ, ws, dist0, se0, &diskQ );
			osRecvMesg( &diskQ, NULL, OS_MESG_BLOCK );

			n64dd_error_no = GET_ERROR( cmdBlock );
			if ( n64dd_error_no ) return;

			ws = ws + se0;
			leftbyte -= sumbyte0;
			dist0 = (u32*)( dist + (sumbyte0 >> 2) );

		}
		/* Ⱦü֥åϰöХåեȤ */
		LeoReadWrite( &cmdBlock, OS_READ, ws, n64dd_t.a, 1, &diskQ );
		osRecvMesg( &diskQ, NULL, OS_MESG_BLOCK );

		n64dd_error_no = GET_ERROR( cmdBlock );
		if ( n64dd_error_no ) return;

		/*osSyncPrintf( " ** NOKORI: %d  \n", leftbyte );*/
		/* ХåեŪΰ */
		sdma = (s32*)n64dd_t.a;
		do{
			*dist0++ = *sdma++;
			leftbyte -= 4;
		} while( leftbyte > 0 );
		
		/* ǰΤ n64dd_t.a ˼̻Ҥ¸ߤʤ褦 */
		n64dd_t.a[0] = '\0';
		osWritebackDCacheAll();
	}

}
