#define __N64DD_C
/*****************************************************************
 *
 *		n64dd 饤֥ version 1.0   97/02/06
 *								 2.6   97/05/09
 *		(Υϥ֥=4 Ǹ)
 *
 *****************************************************************/


/*****************************************************************
 *		󥯥롼
 */

#include <ultra64.h>

#ifdef V2_0G
#  include <leoappli.h>
#  include "myleoapi.h"
#else
#  include <leo.h>
#endif

#include "n64dd.h"

/*****************************************************************
 *		ѿ
 */

/* ==== ǥȥХåե */
n64dd_Disk_buffer		n64dd_t = { { 0 } };

/* ====  LBA κȤΤΥХåե */
n64dd_File_usebit_work	n64dd_usebit = { { 0 } };

/* ==== եŸΤκΰ */
n64dd_File_info	n64dd_expanded_table;

/* ==== եơ֥ιܿ */
s32	n64dd_ftablelen = 0;

/* ==== DD  */
LEOCapacity		n64dd_cap = { 0 };

/* ==== ǥID */
LEODiskID		n64dd_myDiskID = { 0 };

/* ==== 顼ֹ */
s32 n64dd_error_no = 0;

/* ==== ǥ顼ե饰 */
s32 n64dd_always_error = 0;		/* öꤵ줿 n64dd_newdisk Ǥʤ */

/* ==== å塼 */
OSMesgQueue     diskQ;
OSMesg          diskQBuf;


#define n64dd_always_error_check();		if ( n64dd_always_error ){ n64dd_error_no = n64dd_always_error; return -1; }


/*****************************************************************
 *		ǥѥå塼
 */
void n64dd_createQ( void )
{
	osCreateMesgQueue( &diskQ, &diskQBuf, 1 );
}

/*****************************************************************
 *		ǥޥ͡
 */
s32 n64dd_create_manager( void )
{
	if ( n64dd_create_manager0( N64DD_DISK_BOOT ) < 0 ) return -1;
	return 0;
}
/********************************/
s32 n64dd_create_manager0( int media )
{
	/* ==== ǥȥХåեꥢ: ̻Ҥʤ褦ˡ */
	n64dd_t.a[0] = '\0';

	/* ==== ǥޥ͡ */
	switch( media ){
	case N64DD_CARTRIDGE_BOOT:
		n64dd_error_no = LeoCCreateLeoManager( (OSPri)OS_PRIORITY_LEOMGR - 1, (OSPri)OS_PRIORITY_LEOMGR, &diskQBuf, 1, LEO_COUNTRY_JAPAN );
		break;
	default:
		n64dd_error_no = LeoCreateLeoManager( (OSPri)OS_PRIORITY_LEOMGR - 1, (OSPri)OS_PRIORITY_LEOMGR, &diskQBuf, 1 );
		break;
	}

	/* ==== Ԥʤ齪λ */
	if ( n64dd_error_no != LEO_ERROR_GOOD ) return -1;

	/* ==== ȥåưʤ ID åʤ */
	if ( media == N64DD_CARTRIDGE_BOOT ) return 0;

	/* ==== ID ɤ */
	while(1){
		n64dd_read_diskID( &n64dd_myDiskID );
		if ( n64dd_error_no == 0 ) break;
		if ( (n64dd_error_no == LEO_ERROR_MEDIUM_NOT_PRESENT) || (n64dd_error_no == LEO_ERROR_MEDIUM_MAY_HAVE_CHANGED) ) continue;
		return -1;
	}
	
	/* ==== ֡ID Ȥ */
	if ( bcmp( (void*)&leoBootID, (void*)&n64dd_myDiskID, sizeof(LEODiskID) ) == 0 ) return 0;

	n64dd_error_no = N64DD_DISKID_ILLEGAL;
	return -1;

}
/*****************************************************************
 *		ǥϢѿ
 */
s32	n64dd_newdisk( void )
{
	if ( n64dd_read_diskID( &n64dd_myDiskID ) ) return -1;
	if ( n64dd_check() < 0 ) return -1;

	if ( n64dd_cap.nbytes == 0 ){
		n64dd_error_no = N64DD_READ_ONLY_MEDIA;
		n64dd_always_error = N64DD_READ_ONLY_MEDIA;
		return -1;
	}

	return 0;
}

/*****************************************************************
 *		ǥ񤭹̥å
 */
s32 n64dd_check( void )
{
	s32		byte;

	n64dd_error_no = LeoReadCapacity( &n64dd_cap, OS_WRITE );

	if ( n64dd_error_no != LEO_ERROR_GOOD  )	return -1;

	/*osSyncPrintf( "startLBA %x\n", n64dd_cap.startLBA );
	osSyncPrintf( "endLBA   %x\n", n64dd_cap.endLBA );
	osSyncPrintf( "nbytes   %x\n", n64dd_cap.nbytes );*/

	/* ==== ơ֥ιܿ׻ */
	LeoLBAToByte( n64dd_cap.startLBA, 1, &byte );
	n64dd_ftablelen = (byte - 16 - 368) >> 4;
	/* osSyncPrintf( "ftablelen %d(%x)\n", n64dd_ftablelen, n64dd_ftablelen ); */

	return 0;
}
/*****************************************************************
 *		ǥ n64dd Ѥå
 */
s32 n64dd_check_media_init( void )
{
	/* ==== ʥǥ */
	n64dd_always_error_check();

	while(1){
		/* ==== ǥ ɤ߽ΰǽΥեơ֥ɤ߹ */
		n64dd_LeoReadWrite_READ( n64dd_cap.startLBA, n64dd_t.a, 1 );

		/* ==== 顼å */
		if ( n64dd_error_no == 0 ) break;
		if ( n64dd_error_no == LEO_ERROR_MEDIUM_MAY_HAVE_CHANGED ) continue;
		if ( n64dd_error_no == LEO_ERROR_UNRECOVERED_READ_ERROR ) return 0;

		/* ====  */
		return -1;
	}
		
	osWritebackDCache( n64dd_t.a, N64DD_IDSTRLEN );

	/* ɥå */
	if ( n64dd_check_keyword() == 0 ) return 1;

	n64dd_error_no = N64DD_MEDIA_NOT_INIT;
	return 0;
}

/*****************************************************************
 *		ɥå֥롼
 *		N64DD_IDSTR (ʸĹ: N64DD_IDSTRLEN) Υå
 */
s32 n64dd_check_keyword( void )
{
	int			i, flag=0;
	char		idstr[] = N64DD_IDSTR;
	n64dd_FAT 	*f;

	f = (n64dd_FAT*)n64dd_t.a;

	/* ==== ɥå */
	for( i=0; i<N64DD_IDSTRLEN; i++ ){
		if ( f->diskID[ i ] != idstr[ i ] ) flag++;
	}

	return ( flag )? -1: 0;
}
/*****************************************************************
 *		ե륷ƥ
 */
s32 n64dd_media_init( void )
{
	n64dd_FAT 	*f;
	int			i, j;
	char		idstr[] = N64DD_IDSTR;

	/* ==== ʥǥ */
	n64dd_always_error_check();

	/* ==== ǥ¸ߤ뤫 */
	if ( n64dd_check_insert() <= 0 ){
		return -1;
	}

	f = (n64dd_FAT*)n64dd_t.a;

	/* ==== ID ʸ å */
	for( i=0; i<N64DD_IDSTRLEN; i++ )		f->diskID[ i ] = idstr[ i ];

	/* ==== ΰ襯ꥢ( ƬΥơ֥ͽ)  */
	f->use[ 0 ] = 0x80;
	for( i=1; i<N64DD_USEBITLEN; i++ )		f->use[ i ] = 0;

	/* ==== ơ֥륯ꥢ */
	for( i=0; i<n64dd_ftablelen; i++ ){
		for( j=0; j<12; j++ ) f->fat[i].info[j] = 0;
		f->fat[i].use = 0;
		f->fat[i].connect = 0xffff;
	}

	/* ==== ǥ˽񤭹 */
	if ( n64dd_LeoReadWrite_WRITE( n64dd_cap.startLBA, n64dd_t.a, 1 ) < 0 ) return -1;
	return 0;
}
/*****************************************************************
 *		̾θȾŸ
 *			̾ˡǼƤƬơֹ֥֤ 0,1,2,....
 *			Ĥʤʤ -1
 */
s32 n64dd_search_name( char *name )
{
	int 		i;
	n64dd_FAT	*f;

	f = (n64dd_FAT*)n64dd_t.a;

	for( i=0; i<n64dd_ftablelen; i++ ){

		/* ==== ơ֥뤬ƬǤʤʤѥ */
		if ( f->fat[i].use != 1 ) continue;

		/* ==== Τ̾Ÿ̾ */
		n64dd_expand_info_name( i );
		if ( n64dd_strcmp( n64dd_expanded_table.name, name ) == 0 ) return i;
	}

	return -1;
}

#define n64dd_namelen_check( len );		{ if ( (len<=0) || (len>255) ){ n64dd_error_no = N64DD_ARGUMENT_ILLEGAL; return -1; } }

/*****************************************************************
 *		ե񤭹(Ʊ̾եݸ)
 *			Ʊ̾եݸפȤϡ֤褦ȤեƱ̾ե뤬ä硢
 *			ƥݥǥ֤ơǧΥեäȤؤƤ롣
 *			äơե LBA ֤ɬѲ뤷ƥݥʬǥ
 *			ΰ;͵ɬפˤʤ롣
 */
s32 n64dd_save( char *name, u32 *src, s32 length, char *creator, char *filetype )
{
	int		old, len;

	/* ==== å */
	if ( length <= 0 ){
		n64dd_error_no = N64DD_ARGUMENT_ILLEGAL;
		return -1;
	}
	len = n64dd_strlen( name );
	n64dd_namelen_check( len );

	/* ==== ǥξ֥å */
	if ( n64dd_check_valid() < 0 ) return -1;

	/* ==== Ǥ˳ǼƤ뤫 */
	old = n64dd_search_name( name );
	if ( old >= 0 ){
		/* öƥݥեäƤǽ񤭴 */
		if ( n64dd_create_file( "__TMP__", src, length, creator, filetype ) < 0 ){
			n64dd_error_no = N64DD_AREA_LACKED;
			return -1;
		}
		n64dd_delete_file_sub( name );
		n64dd_rename_file( "__TMP__",  name );
	}
	else{
		if ( n64dd_create_file( name, src, length, creator, filetype ) < 0 ){
			return -1;
		}
	}

	/* ==== FAT 񤭤 */
	/* ǼԤ褦ȥǥ㤰ˤʤäƤǽ */
	if ( n64dd_ftable_flush() < 0 ) return -1;

	return 0;
}

/*****************************************************************
 *		ե񤭹(Ʊ̾ե)
 *			Ʊ̾եפȤϡ
 *			Ʊե̾Υե뤬ä硢ޤƤ
 *			ֽ뤳ȤؤƤ롣
 *			äơƱ̾եƱʤСΰ褬­
 *			ȤϤʤ
 *			(: ΰ襹ƬʤΤǡɬƱΰ˥֤櫓ǤϤʤ)
 */
s32 n64dd_save_deletefirst( char *name, u32 *src, s32 length, char *creator, char *filetype )
{
	int		old, len;
	int		ret_value = 0;

	/* ==== å */
	if ( length <= 0 ){
		n64dd_error_no = N64DD_ARGUMENT_ILLEGAL;
		return -1;
	}
	len = n64dd_strlen( name );
	n64dd_namelen_check( len );

	/* ==== ǥξ֥å */
	if ( n64dd_check_valid() < 0 ) return -1;

	/* ==== Ǥ˳ǼƤ뤫 */
	old = n64dd_search_name( name );
	if ( old >= 0 ){
		n64dd_delete_file_sub( name );
		if ( n64dd_create_file( name, src, length, creator, filetype ) < 0 ){
			n64dd_error_no = N64DD_AREA_LACKED;
			ret_value = -1;
		}
	}
	else{
		if ( n64dd_create_file( name, src, length, creator, filetype ) < 0 ){
			return -1;
		}	
	}

	/* ==== FAT 񤭤 */
	/* ǼԤ褦ȥǥ㤰ˤʤäƤǽ */
	if ( n64dd_ftable_flush() < 0 ) ret_value = -1;
	return ret_value;
}

/*****************************************************************
 *		ե񤭹(ƱΰѤ)
 *			ƱΰѤפȤϡ
 *			δؿDD ¸ߤե̾Υե̾ƱΥե
 *			鷺˽񤭹ˤϸŤΥե򤽤äѤ뤳Ȥ̣롣
 *			Ťե뤬ʬ䤵ƤǤ⡢ɬʬѤȤȤʤ롣
 *			ʤե뤬¸ߤʤϥ顼
 */
s32 n64dd_save_samearea( char *name, u32 *src )
{
	int			num, pos;
	int			ret_value = 0;
	u8			*src0 = (u8*)src;
	s16			ws, se;
	s32			leftbyte, sumbyte, len;

	/* ==== å */
	len = n64dd_strlen( name );
	n64dd_namelen_check( len );

	/* ==== ǥξ֥å */
	if ( n64dd_check_valid() < 0 ) return -1;				/* : n64dd_error_no ˸ */

	/* ==== ե¸ߥå */
	if ( (num = n64dd_search_name( name )) < 0 ){
		n64dd_error_no = N64DD_NOT_FOUND;					/* : n64dd_error_no ˸(ե뤬¸ߤʤ) */
		return -1;
	}	

	/* ==== ꥹȤ˥ե륵ʹߤɤ */
	n64dd_expand_info( num );

	/* ==== ĤХȿ򥻥å */
	leftbyte = n64dd_expanded_table.size;

	/* ==== 񤭹ߥ롼 */
	for( pos = 0;  ;  pos++ ){
		ws = n64dd_expanded_table.info[pos].startLBA;
		se = n64dd_expanded_table.info[pos].useLBA;
		if ( ws == 0 ) break;

		/* osSyncPrintf( "%d %d  %d(%x)\n", ws, se, leftbyte, leftbyte ); */

		/* 񤭹Ȥ礭 */
		LeoLBAToByte( n64dd_cap.startLBA + ws, se, &sumbyte );

		/* 񤭹 */
		n64dd_LeoReadWrite_WRITE( n64dd_cap.startLBA + ws, src0, se );

		/* ݥ󥿼 */
		src0     += sumbyte;
		leftbyte -= sumbyte;

		/*  */
		if ( leftbyte <= 0 ) break;
	}

	/* ==== FAT 񤭤 */
	/* ǼԤ褦ȥǥ㤰ˤʤäƤǽ */
	if ( n64dd_ftable_flush() < 0 ) ret_value = -1;

	return ret_value;
}

/*****************************************************************
 *		եζ֥롼
 *		 : -1 Ǽ
 */
s32 n64dd_create_file( char *name, u32 *src, s32 bytes, char *creator, char *filetype )
{
	s16			write_sec;
	s16			secs;
	s32			retbyte;
	s32			leftbytes = bytes;
	u8			*src0 = (u8*)src;			/* βžΰƬ */
	
	/* եơ֥ */
	/*f = (n64dd_FAT*)n64dd_t.a;*/

	/* ̾Хȿꥨե륿פϿ */
	n64dd_resist_name( name );
	n64dd_resist_bytes( bytes );
	n64dd_resist_creator( creator );
	n64dd_resist_filetype( filetype );
	n64dd_resist_createtime();

	/* ѥӥåȾƥݥ˼ */
	n64dd_import_usebit();

	/* Ǽΰ */
	n64dd_expanded_table.info[0].startLBA = n64dd_expanded_table.info[0].useLBA = 0;


	/* 񤭹ߥ롼 */
	while( leftbytes > 0 ){
		/* βν񤭹ߥꥢƬ */
		/*osSyncPrintf( "NOKORI: %lx  SENTOU %lx\n", leftbytes, src0 );*/

		/* leftbytes ʬζꥢõ*/
		n64dd_search_blankLBA( leftbytes, &write_sec, &secs, &retbyte );
		/*osSyncPrintf( "get LBA: write LBA:%x   LBAs:%x   Bytes:%lx \n", write_sec, secs, retbyte );*/

		if ( (secs <= 0) || (write_sec <= 0) ){				/* ׵ХȤФƥꥢʤä */
			/*osSyncPrintf( "No space (LBA) to write file.\n" );*/

			/* ޤǹƤʬ⥭󥻥 */
			n64dd_delete_usebit();

			n64dd_error_no = N64DD_AREA_LACKED;			/* : n64dd_error_no = (ΰ褬­ʤ) */			
			return -1;
		}

		/* 񤭹 */
		if ( n64dd_LeoReadWrite_WRITE( n64dd_cap.startLBA + write_sec, src0, secs ) < 0 ){
			/* ޤǹƤʬ⥭󥻥 */
			n64dd_delete_usebit();
			return -1;									/* : n64dd_error_no  (񤭹ߤǲ) */
		}

		/* ĤХȿ */
		leftbytes = ( retbyte >= bytes )? 0: (leftbytes - retbyte);
		src0 += retbyte;

		/* ѥӥåȤΩƤơꥹȤϿ */
		n64dd_set_usebit( write_sec, secs );
		n64dd_resistLBA( write_sec, secs );
	}

	/* FAT ( ǥ˽񤭽ФΤǤϤʤ) */
	if ( n64dd_write_tmpfat() < 0 ){
		n64dd_delete_usebit();							/* ޤǹƤʬ⥭󥻥 */
		return -1;										/* : n64dd_error_no ˸(餯ΰ褬­ʤ) */
	}

	/* ѥӥåȾƥݥ꤫եå */
	n64dd_export_usebit();

	return 0;
}

/*****************************************************************
 *		̾ŸΰϿ
 */
s32 n64dd_resist_name( char *name )
{
	int 	pos = 0;
	n64dd_File_info		*e = &n64dd_expanded_table;

	/* ̾Ͽ */
	while(1){
		e->name[ pos ] = name[ pos ];
		if ( name[ pos++ ] == '\0' ) break;
		if ( pos >= 256 ){ e->name[ 255 ] = '\0';  break; }
	}

	return 0;
}

/*****************************************************************
 *		ե礭ŸΰϿ
 */
s32 n64dd_resist_bytes( u32 bytes )
{
	n64dd_expanded_table.size = bytes;
	return 0;
}

/*****************************************************************
 *		ꥨŸΰϿ
 */
s32 n64dd_resist_creator( char *creator )
{
	int 	i, flag=0;
	char 	c;
	u8				tmp_info[4] = { 0, 0, 0, 0 };

	*(u32*)(n64dd_expanded_table.creator) = 0;
	
	if ( creator == NULL )	creator = tmp_info;

	for( i=0; i<4; i++ ){
		if ( ( c = *(creator + i) ) == '\0' ) flag = 1;
		if ( flag ) c = 0;
		*(n64dd_expanded_table.creator + i) = c;
	}
	return 0;
}

/*****************************************************************
 *		ե륿׾ŸΰϿ
 */
s32 n64dd_resist_filetype( char *filetype )
{
	int 	i, flag=0;
	char	c;
	u8				tmp_info[4] = { 0, 0, 0, 0 };

	*(u32*)(n64dd_expanded_table.filetype) = 0;
	
	if ( filetype == NULL ) filetype = tmp_info;

	for( i=0; i<4; i++ ){
		if ( ( c = *(filetype + i) ) == 0 ) flag = 1;
		if ( flag ) c = 0;
		*(n64dd_expanded_table.filetype + i) = c;
	}
	return 0;
}

/*****************************************************************
 *		եŸΰϿ
 */
s32 n64dd_resist_createtime( void )
{
	if ( n64dd_get_RTC_raw( &n64dd_expanded_table.time ) < 0 ) return -1;

	return 0;
}

/*****************************************************************
 *		ե°
 */
/*s32 n64dd_reset_atribute( int num, char *creator, char *filetype )*/

/*****************************************************************
 *		եκ
 */
/*s32 n64dd_reset_createtime( int num, char *creator, char *filetype )*/


/*****************************************************************
 *		եơ֥ζõ
 *		-1 ʤ ԡʳͤΰ衣
 */
s32 n64dd_ftable_blank( void )
{
	int 		i;

	for( i=0; i<n64dd_ftablelen; i++ ){
		if ( (u16)n64dd_t.fat.fat[i].use == 0 ){
			return i;
		}
	}
	return -1;
}

/*****************************************************************
 *		եơ֥˰ŸΰƤ񤭹
 */

s32 n64dd_write_tmpfat( void )
{
	int				num, fp, pos,   next_num, start_num, flag, i;
	n64dd_FAT		*f;
	n64dd_File_info	*e;

	/* ǥξ֥å */
	if ( n64dd_check_valid() < 0 ) return -1;

	/* ơ֥ΰõ */
	if ( (start_num = n64dd_ftable_blank()) < 0 ){
		n64dd_error_no = N64DD_AREA_LACKED;
		return -1;
	}

	f = (n64dd_FAT*)n64dd_t.a;
	e = &n64dd_expanded_table;

	num = start_num;
	f->fat[num].connect = 0xffff;
	f->fat[num].use = 1;
	fp = 0;

	/* ե̾񤭹 */
	flag = pos = 0;
	while( flag == 0 ){
		if ( (f->fat[num].info[fp++] = e->name[ pos++ ]) == '\0' ) flag++;

		if ( fp >= N64DD_INFO_SIZE ){
			next_num = n64dd_ftable_blank();

			/* ơ֥ΰõ */
			if ( next_num < 0 ){

				/* ޤǤ ơ֥õξ塢 */
				n64dd_delete_ftable( start_num );
				n64dd_error_no = N64DD_AREA_LACKED;
				return -1;
			}

			f->fat[num].connect = next_num;
			num = next_num;
			f->fat[num].connect = 0xffff;
			f->fat[num].use = 2;
			fp = 0;
		}
	}

	/* 4Хȥ饤 */
	while( fp & 3 )		f->fat[num].info[fp++] = 0;

	/* Хȿꥨե륿סǼΰ ν񤭹 */
	for( pos = 0, i=0;   ; i++ ){
		u8		*data;
		int		end_flag = 0;

		switch( i ){
		case 0:	/* Хȿ */
			data = (u8*)&(e->size);
			break;
		case 1:	/* ꥨ */
			data = (u8*)&(e->creator);
			break;
		case 2:	/* ե륿 */
			data = (u8*)&(e->filetype);
			break;
		case 3: /* ե(Ⱦ) */
			data = (u8*)&(e->time);
			break;
		case 4: /* ե(Ⱦ) */
			data = (u8*)&(e->time) + 4;
			break;
		default:	/* Ǽΰ */
			data = (u8*)&(e->info[pos].startLBA);
			pos++;
			if ( *(u32*)data == 0 ) end_flag = 1;
		}

		if ( fp+4 > N64DD_INFO_SIZE ){
			/* λǡϼΰ˷ۤʤ */
			if ( end_flag ) break;

			next_num = n64dd_ftable_blank();

			if ( next_num < 0 ){
				/* ʤä顩 */

				/* ޤǤ ơ֥õξ塢 */
				n64dd_delete_ftable( start_num );
				n64dd_error_no = N64DD_AREA_LACKED;
				return -1;
			}

			f->fat[num].connect = next_num;
			num = next_num;
			f->fat[num].connect = 0xffff;
			f->fat[num].use = 2;
			fp = 0;
		}

		/* Υǡ񤭹 */
		*(u32*)&(f->fat[num].info[fp]) = (u32)*((u32*)data);
		fp += 4;

		/* λå */
		if ( end_flag )	break;
	}

	return 0;
}

/*****************************************************************
 *		FAT  ǥݤФ
 */
s32 n64dd_ftable_flush( void ){

	return n64dd_LeoReadWrite_WRITE( n64dd_cap.startLBA, n64dd_t.a, 1 );
}

/*****************************************************************
 * 		ѥӥåȤΥå(ƥݥѥӥåȾ򥻥å)
 */
s32 n64dd_set_usebit( s16 write_sec, s16 secs )
{
	int  ws = write_sec;		/* ߽񤭤Ǥ(ơֹ֥) */
	int	 se = secs;				/* Ĥ񤭹ߥӥå */
	int	 p;						/* 񤭹֤߰Хñ̤ˤ */

	/* ǥξ֥å */
	/*if ( n64dd_check_valid() < 0 ) return -1;				/* : n64dd_error_no ˸ */

	if ( se <= 0 ) return 0;
	if ( ws + se > (n64dd_cap.endLBA - n64dd_cap.startLBA) ) return -1;

	/* ǽȾü */
	p = ws >> 3;
	while( ( ws & 7 ) != 0 ){
		n64dd_usebit.a[ p ]   |=    1 << ( 7 - (ws & 7) );
		if ( --se <= 0 ){
			return 0;
		}
		ws++;
	}

	/* ޤȤޤä ֥å */
	p = ws >> 3;
	while( se >= 8 ){
		n64dd_usebit.a[ p++ ] = 0xff;		
		se -= 8;
		ws += 8;
	}

	/* Ⱦü */
	p = ws >> 3;
	while( se > 0 ){
		n64dd_usebit.a[ p ]   |=    1 << ( 7 - (ws & 7) );
		ws++;
		se--;
	}

	return 0;
}
/*****************************************************************
 * 		ѥӥåȤΥ󥻥å(ƥݥѥӥåȾ򥢥󥻥å)
 */
s32 n64dd_unset_usebit( s16 write_sec, s16 secs )
{
	int  ws = write_sec;		/* ߽񤭤Ǥ(ơֹ֥) */
	int	 se = secs;				/* Ĥ񤭹ߥӥå */
	int	 p;						/* 񤭹֤߰Хñ̤ˤ */

	if ( se <= 0 ) return 0;

	/* ǽȾü */
	p = ws >> 3;
	while( ( ws & 7 ) != 0 ){
		n64dd_usebit.a[ p ]   &=    (0xff ^ (1 << ( 7 - (ws & 7) )) );
		if ( --se <= 0 ){
			return 0;
		}
		ws++;
	}

	/* ޤȤޤä ֥å */
	p = ws >> 3;
	while( se >= 8 ){
		n64dd_usebit.a[ p++ ] = 0;		
		se -= 8;
		ws += 8;
	}

	/* Ⱦü */
	p = ws >> 3;
	while( se > 0 ){
		n64dd_usebit.a[ p ]   &=  (0xff ^ (1 << ( 7 - (ws & 7) )) );
		ws++;
		se--;
	}

	return 0;
}

/*****************************************************************
 * 		ѥӥåȾ󡧥ǥƥݥ
 */
s32 n64dd_import_usebit( void )
{
	n64dd_FAT	*f;

	/* ǥξ֥å */
	if ( n64dd_check_valid() < 0 ) return -1;				/* : n64dd_error_no ˸ */

	f = (n64dd_FAT*)n64dd_t.a;

	bcopy( f->use, n64dd_usebit.a, sizeof( f->use ) );

	return 0;
}

/*****************************************************************
 * 		ѥӥåȾ󡧥ƥݥ꤫ǥ
 */
s32 n64dd_export_usebit( void )
{
	n64dd_FAT	*f;

	/* ǥξ֥å */
	if ( n64dd_check_valid() < 0 ) return -1;				/* : n64dd_error_no ˸ */

	f = (n64dd_FAT*)n64dd_t.a;

	bcopy( n64dd_usebit.a, f->use, sizeof( f->use ) );

	return 0;
}

/*****************************************************************
 * 		ǼLBA  Ÿơ֥ΰ˥å
 */
s32 n64dd_resistLBA( s16 write_sec, s16 secs )
{
	int pos = 0;

	while( n64dd_expanded_table.info[ pos ].startLBA != 0 ){
		pos++;
	}
	if ( pos >= N64DD_MAX_INFO_PAIR ){
		n64dd_error_no = N64DD_AREA_LACKED;
		return -1;
	}

	n64dd_expanded_table.info[ pos ].startLBA = write_sec;
	n64dd_expanded_table.info[ pos ].useLBA   = secs;
	/*osSyncPrintf( "RESIST: %x, %x\n", write_sec, secs );*/

	/* ȤꤢɥޡƤ */
	n64dd_expanded_table.info[ pos+1 ].startLBA = 0;
	n64dd_expanded_table.info[ pos+1 ].useLBA   = 0;

	return 0;
}

/*****************************************************************
 *		 LBA  õ
 *			 leftbytes ΰ褬ߤԤʤ write_sec = -1;
 *			 ʤλ(ĤäȤᤤ)֥åȤ롣
 */
s32 n64dd_search_blankLBA( s32 bytes, s16* write_sec, s16* secs, s32* b )
{
	int	 	ws = -1;	/* ߤκǤŬʽ񤭹 LBA Ƭ(0ꥸ) */
	int	 	se = -1;	/* ߤκǤŬʽ񤭹 LBA  */
	int	 	wb = -1;	/* ߤκǤŬʽ񤭹 Хȿ */
	s32		sumbyte;	/* ݥХȤ߷ */
	s32		sumLBA;		/* Ϣ³Ƥݲǽ LBA  */
	int		ws0;		/* Υ֥åƬ */
	int		ws1;		/* Υ󥰥֥å */
	int		flag;

	for( ws0=1;  ws0<=(n64dd_cap.endLBA - n64dd_cap.startLBA); ws0++ ){

		/* ޤΰƬõ */
		if ( n64dd_usebit.a[ ws0>>3 ] & ( 1 << ( 7-( ws0 & 7 ) ) ) ) continue;
		
		/* ֥åϢ³Хȿ׻ */
		ws1 = ws0;
		sumLBA = 0;
	
		while( ws1 <=(n64dd_cap.endLBA - n64dd_cap.startLBA) ){
			if ( n64dd_usebit.a[ ws1>>3 ] & ( 1 << ( 7-( ws1&7 ) ) ) ) break;
			sumLBA ++;
			ws1++;
		}
		LeoLBAToByte( n64dd_cap.startLBA + ws0, sumLBA, &sumbyte );

		/* ΤΤ褱кŬʤΤ򹹿 */
		flag = 0;
		if ( ( wb < bytes ) && ( sumbyte > bytes ) ) 	flag++;	/* ϴ˾꾯ʤ٤ϴ˾¿Ȥ */
		if ( ( sumbyte <= bytes ) && ( wb < sumbyte ) )	flag++;	/* ˾ʲεϿ礭 */
		if ( ( sumbyte >= bytes ) && ( wb > sumbyte ) ) flag++;	/* ˾ʾεϿϾ */
		if ( flag ){		
			ws = ws0; se = sumLBA; wb = sumbyte;				/* Ͽ */
		}
		ws0 = ws1;
	}

	/* ʤä鼺 */
	if ( wb < 0 ){
		*write_sec = -1;
		*secs = 0;
		*b = 0;
		return -1;
	}

	/* ⤷˾ХȤ¿Ȥ줿Τʤ;ʬ LBA ʤ褦˺Ǿ¤ˤ */
	if ( wb > bytes ){
		for( ws0=1; ws0<=se; ws0++ ){
			LeoLBAToByte( n64dd_cap.startLBA + ws, ws0, &sumbyte );
			if ( sumbyte >= bytes ) break;						/* Ķڤ */
		}
		se = ws0;
		wb = sumbyte;
	}

	*write_sec = ws;
	*secs = se;
	*b = wb;
	return 0;
}

/*****************************************************************
 *  	եξõ(FAT 񤭽Ф)
 *		ե̾ꤷơΰߤǾäƤޤ
 */
s32 n64dd_delete_file( char *name )
{
	if ( n64dd_delete_file_sub( name ) < 0 )	return -1;

	/* FAT 񤭤 */
	if ( n64dd_ftable_flush() < 0 ) return -1;

	return 0;
}
/*****************************************************************
 *  	եξõ(⥸塼)
 *		ե̾ꤷơΰߤǾäƤޤ
 */
s32 n64dd_delete_file_sub( char *name )
{

	int		info_num, pos;


	/* ǥξ֥å */
	if ( n64dd_check_valid() < 0 ) return -1;

	/* ơ֥Ǥΰõ */
	info_num = n64dd_search_name( name );
	if ( info_num < 0 ){
		n64dd_error_no = N64DD_NOT_FOUND;
		return -1;
	}
	
	/* եơ֥Ÿ */
	n64dd_expand_info( info_num );

	/* ѥӥåȾ */
	n64dd_import_usebit();

	/* ΰõ롼 */
	for( pos=0; ; pos++ ){
		int s, u;

		s = n64dd_expanded_table.info[pos].startLBA;
		u = n64dd_expanded_table.info[pos].useLBA;

		if ( s == 0 ) break;

		n64dd_unset_usebit( s, u );
	}

	/* եơ֥õ */
	n64dd_delete_ftable( info_num );

	/* ѥӥåȾ򹹿 */
	n64dd_export_usebit();

	return 0;
}
/*****************************************************************
 *		ե̾ѹ
 */
s32 n64dd_rename_file( char *old_name, char *new_name ){
	s16		old_num;
	
	/* FATǼ */
	old_num = n64dd_search_name( old_name );
	
	/* ե¸߳ǧ */
	if ( old_num < 0 ){	/* Ĥʤä */
		n64dd_error_no = N64DD_NOT_FOUND;
		return -1;
	}
	
	/* եơ֥Ÿ */
	n64dd_expand_info( old_num );

	/* ̾ѹ */
	n64dd_resist_name( new_name );
	
	/* ꥹȤ եơ֥Ͽ */
	if ( n64dd_write_tmpfat() < 0 ) return -1;

	/* Ťեơ֥()򤽤ä */
	n64dd_delete_ftable( old_num );

	return 0;
}
/*****************************************************************
 *		եơ֥
 *		ΰκԤʤ
 */
s32 n64dd_delete_usebit( void )
{
	int s, u, pos;
	
	/* ΰõ롼 */
	for( pos=0; ; pos++ ){
		s = n64dd_expanded_table.info[pos].startLBA;
		u = n64dd_expanded_table.info[pos].useLBA;

		if ( s == 0 ) break;

		n64dd_unset_usebit( s, u );
	}

	return 0;
}

/*****************************************************************
 *		եơ֥
 *		ΰʤɤϤʤ
 */
s32 n64dd_delete_ftable( s32 num )
{
	n64dd_FAT 	*f;
	s32			next_num;

	f = (n64dd_FAT*)n64dd_t.a;

	while(1){
		next_num = f->fat[num].connect;
		f->fat[num].use = 0;
		f->fat[num].connect = 0xffff;
		if ( next_num > n64dd_ftablelen ) break;
		num = next_num;
	}

	return 0;
}

/*****************************************************************
 *		եɤ߹
 *		name ǻꤷեɤ dist ˳Ǽ롣
 *		â byte ХȤޤɤ߹ࡣ
 *
 */
s32 n64dd_load( char *name, u32 *dist, s32 byte )
{
	int			fnum;
	s16			ws, se, ws0, pos;
	s32			leftbyte = byte, orgbyte;
	s32			sumbyte, sumbyte0;
	char		*dist0 = (char *)dist;						/* եɤ߹ */
	n64dd_File_info	*e;

	e = &n64dd_expanded_table;

	/* å */
	if ( byte < 0 ){
		n64dd_error_no = N64DD_ARGUMENT_ILLEGAL;
		return -1;
	}

	/* ǥξ֥å */
	if ( n64dd_check_valid() < 0 ) return -1;

	/* ե¸ߥå */
	fnum = n64dd_search_name( name );
	if ( fnum < 0 ){
		n64dd_error_no = N64DD_NOT_FOUND;
		return -1;
	}

	/* եɤ߹ */
	n64dd_expand_info( fnum );

	/* ꥸʥ륵Ȥ */
	orgbyte = e->size;
	if ( (leftbyte == 0 ) || ( leftbyte > orgbyte ) )	leftbyte = orgbyte;

	/* ɤ߹ߥ롼 */
	for( pos = 0; ; pos++ ){
		ws = e->info[pos].startLBA;
		se = e->info[pos].useLBA;
		if ( ws == 0 ) break;		

		/* Τޤɤ鲿ХȤˤʤ롩 */
		LeoLBAToByte( n64dd_cap.startLBA + ws, se, &sumbyte );

		/* ΤޤɤŪХȤĶ(ɬ LBA ǽ) */
		if ( leftbyte < sumbyte ){
			
			/* Ⱦü֥åõ */
			for( ws0=1; ws0<=se; ws0++ ){
				LeoLBAToByte( n64dd_cap.startLBA + ws, ws0, &sumbyte0 );
				if ( sumbyte0 > leftbyte ) break;		/* ĤХȤĶ */
			}

			/* ݡɤǤ֥å꤫ */
			if ( ws0 >= 2 ){
				ws0--;

				/* ݡɤ */
				LeoLBAToByte( n64dd_cap.startLBA + ws, ws0, &sumbyte0 );
				if ( n64dd_LeoReadWrite_READ( n64dd_cap.startLBA + ws, dist0, ws0 ) < 0 ) return -1;		/* : n64dd_error_no ˸ */

				ws = ws + ws0;
				leftbyte -= sumbyte0;
				dist0    += sumbyte0;
			}

			if ( leftbyte == 0 ){
				n64dd_t.a[0] = '\0';
				osWritebackDCacheAll();
				break;		
			}

			/* Ⱦü֥åϰöХåեȤ */
			if ( n64dd_LeoReadWrite_READ( n64dd_cap.startLBA + ws, n64dd_t.a, 1 ) < 0 ){
				n64dd_t.a[0] = '\0';						/* ǰΤ n64dd_t.a ˼̻Ҥ¸ߤʤ褦 */
				return -1;									/* : n64dd_error_no ˸ */
			}

			/* ХåեŪΰ */
			bcopy( n64dd_t.a, dist0, leftbyte );

			/* ǰΤ n64dd_t.a ˼̻Ҥ¸ߤʤ褦 */
			n64dd_t.a[0] = '\0';
			osWritebackDCacheAll();

			/* 롼פȴ */
			break;
		}

		/* ΤޤɤOK */
		if ( n64dd_LeoReadWrite_READ( n64dd_cap.startLBA + ws, dist0, se ) < 0 ) return -1;

		/* ĤХȿȽ񤭹ΰ蹹 */
		leftbyte -= sumbyte;
		dist0    += sumbyte;
	}

	return 0;
}

/*****************************************************************
 *		եɤ߹(ե椫)
 *		name ǻꤷեɤ dist ˳Ǽ롣
 *		âƬ start ХȤΰ֤顢 byte Хɤ߹ࡣ
 *		(硢Ȥϥե륨ɤͥ褹Ȥ̣)
 *
 */
s32 n64dd_load_halfway( char *name, u32 *dist, s32 start, s32 byte )
{
	int			fnum, pos, flag;
	s16			ws, se, ws0;
	s32			startleftbyte, leftbyte = byte, orgbyte;
	s32			sumbyte, sumbyte0;
	char		*dist0 = (char*)dist;
	n64dd_File_info	*e;


	/*osSyncPrintf( "***** HALFWAY *****\n" );*/

	/* å */
	if ( byte < 0 ){
		n64dd_error_no = N64DD_ARGUMENT_ILLEGAL;
		return -1;
	}

	/* ǥξ֥å */
	if ( n64dd_check_valid() < 0 ) return -1;

	/* ե¸ߥå */
	fnum = n64dd_search_name( name );
	if ( fnum < 0 ){
		n64dd_error_no = N64DD_NOT_FOUND;
		return -1;
	}

	/* եơ֥Ÿ */
	n64dd_expand_info( fnum );

	/* ե륵򥹥å */
	e = &n64dd_expanded_table;
	orgbyte = e->size;

	/* ꥸʥ륵Ȥ */
	if ( leftbyte == 0 ) leftbyte = orgbyte - start;
	if ( leftbyte > orgbyte ) leftbyte = orgbyte - start;

	/* Ȱ֤ΰ۾å(ե륵ꥹȰ֤) */
	if ( start >= orgbyte ){
		n64dd_error_no = N64DD_ARGUMENT_ILLEGAL;
		return -1;
	}

	/* Ȱ֤ޤ LBA ޤǥ롼 */
	startleftbyte = start;
	for( pos=0; ; pos++ ){
		ws = e->info[ pos ].startLBA;
		se = e->info[ pos ].useLBA;
	
		/* Ȱ֤ȯ褺 */
		if ( ws == 0 ){
			n64dd_error_no = N64DD_ARGUMENT_ILLEGAL;
			return -1;
		}

		/* Τޤɤ鲿ХȤˤʤ롩 */
		LeoLBAToByte( n64dd_cap.startLBA + ws, se, &sumbyte );

		/*  LBA  Ȱ֤ */
		if ( startleftbyte <= sumbyte ) break;

		/* ΤޤɤǤ⥹Ȱ֤ˤϤʤ */
		startleftbyte -= sumbyte;					/* Ȱ֤ޤǤλĤХȿ */
	}

	/* Τ˥Ȱ֤ޤǥ */
	for( ws0=1; ws0<=se; ws0++ ){
		LeoLBAToByte( n64dd_cap.startLBA + ws, ws0, &sumbyte0 );
		if ( startleftbyte < sumbyte0 ) break;
	}

	/*  LBA(եå) ȡ ɤ߹ LBA  ȡ Ȱ֤ν */
	ws0--;
	LeoLBAToByte( n64dd_cap.startLBA + ws, ws0, &sumbyte0 );
	startleftbyte -= sumbyte0;

	ws = ws + ws0;
	se = se - ws0;

	/* ⤷Ⱦüʤ饹 LBA ɤ߹ȾüöХåեȤ */
	if ( startleftbyte ){
		int length;

		LeoLBAToByte( n64dd_cap.startLBA + ws, 1, &sumbyte0 );

		if ( n64dd_LeoReadWrite_READ( n64dd_cap.startLBA + ws, n64dd_t.a, 1 ) < 0 ){
				n64dd_t.a[0] = '\0';						/* ǰΤ n64dd_t.a ˼̻Ҥ¸ߤʤ褦 */
		}

		length = sumbyte0 - startleftbyte;
		if ( leftbyte < length ) length = leftbyte;

		bcopy( n64dd_t.a + startleftbyte, dist0, length );

		leftbyte -= length;
		dist0    += length;

		ws++;
		se--;
	}

	/* ɬפʤΤäΤʤ®䤫˥꥿ */
	if ( leftbyte <= 0 ){
		return 0;
	}

	/* ⤷ LBA Ͻʤ鼡Τå */
	if ( se == 0 ){
		pos ++;
	}
	/* ޤ LBA ɤΤäȥ */
	else{
		flag = 0;
	}

	/* ɤ߹ߥ롼 */
	for( ; ; pos++ ){
		if ( flag ){
			ws = e->info[pos].startLBA;
			se = e->info[pos].useLBA;
		}
		flag = 1;
		
		/* Τޤɤ鲿ХȤˤʤ롩 */
		LeoLBAToByte( n64dd_cap.startLBA + ws, se, &sumbyte );

		/* ΤޤɤŪХȤĶ(ɬȾü֥åꡢɬ LBA ǽ) */
		if ( leftbyte < sumbyte ){
			
			/* Ⱦü֥åõ */
			for( ws0=1; ws0<=se; ws0++ ){
				LeoLBAToByte( n64dd_cap.startLBA + ws, ws0, &sumbyte0 );
				if ( sumbyte0 >=leftbyte ) break;		/* ĤХȤĶ(ޤƱ) */
			}

			if ( ws0 > 1 ){								/* ݡɤǤ֥å */
				ws0--;
				LeoLBAToByte( n64dd_cap.startLBA + ws, ws0, &sumbyte0 );
				if ( n64dd_LeoReadWrite_READ( n64dd_cap.startLBA + ws, dist0, ws0 ) < 0 ) return -1;

				ws = ws + ws0;
				leftbyte -= sumbyte0;
				dist0 += sumbyte0;
			}

			/* Ⱦü֥åϰöХåեȤ */
			if ( n64dd_LeoReadWrite_READ( n64dd_cap.startLBA + ws, n64dd_t.a, 1 ) < 0 ){
				n64dd_t.a[0] = '\0';					/* ǰΤ n64dd_t.a ˼̻Ҥ¸ߤʤ褦 */
				return -1;								/* : n64dd_error_no ˸ */
			}

			/* ХåեŪΰ */
			bcopy( n64dd_t.a, dist0, leftbyte );
			
			/* ǰΤ n64dd_t.a ˼̻Ҥ¸ߤʤ褦 */
			n64dd_t.a[0] = '\0';
			osWritebackDCacheAll();

			/* 롼פȴ */
			break;
		}

		/* ΤޤɤOK */
		if ( n64dd_LeoReadWrite_READ( n64dd_cap.startLBA + ws, dist0, se ) < 0 ) return -1;

		/* ĤХȿȽ񤭹ΰ蹹 */
		leftbyte -= sumbyte;
		dist0    += sumbyte;

	}
	return 0;
}


/*****************************************************************
 *		ե
 */
s32 n64dd_how_many_file( void )
{
	n64dd_FAT	*f;
	s32			i, fnum = 0;

	/* ǥξ֥å */
	if ( n64dd_check_valid() < 0 ) return -1;				/* : n64dd_error_no ˸ */

	/* եơ֥ */
	f = (n64dd_FAT*)n64dd_t.a;

	/* ե */
	for( i=0; i<n64dd_ftablelen; i++ ){
		if ( f->fat[i].use == 1 ) fnum++;
	}

	return fnum;
}

/*****************************************************************
 *		Ĥơ֥(ɬեǤϤʤ)
 */
s32 n64dd_ftable_left( void )
{
	n64dd_FAT	*f;
	s32			i, fnum = 0;

	/* ǥξ֥å */
	if ( n64dd_check_valid() < 0 ) return -1;

	/* եơ֥ */
	f = (n64dd_FAT*)n64dd_t.a;


	/* ơ֥ */
	for( i=0; i<n64dd_ftablelen; i++ ){
		if ( f->fat[i].use == 0 ) fnum++;
	}

	return fnum;
}

/*****************************************************************
 *		ե
 *		ֹ( 0, 1,...)ꤹȡƬ鸡ƥե̾ե륵ꥨե륿ס ֤
 *      ͤ -1 ʤ鼺
 */
s32 n64dd_get_file_info( s16 fnum, char *fname, u32 *fsize, u8 *creator, u8 *filetype, LEODiskTime *ftime )
{
	n64dd_FAT	*f;
	int			i;

	/* ǥξ֥å */
	if ( n64dd_check_valid() < 0 ) return -1;

	/* եơ֥ */
	f = (n64dd_FAT*)n64dd_t.a;

	/* ե */
	for( i=0; i<n64dd_ftablelen; i++ ){
		if ( f->fat[i].use == 1 )
			if ( fnum-- == 0 ) break;
	}

	/* ե뤬Ĥʤ */
	if ( fnum >= 0 ){
		n64dd_error_no = N64DD_NOT_FOUND;
		return -1;
	}

	/* եơ֥Ÿ */
	n64dd_expand_info( i );

	/* ե̾򥲥å */
	if ( fname ){
		n64dd_strcpy( fname, n64dd_expanded_table.name );
	}

	/* ե륵򥲥å */
	if ( fsize ){
		*fsize = n64dd_expanded_table.size;
	}

	/* ꥨ򥲥å */
	if ( creator ){
		bcopy ( creator, n64dd_expanded_table.creator, 4 );
	}

	/* ե륿פ򥲥å */
	if ( filetype ){
		bcopy ( filetype, n64dd_expanded_table.filetype, 4 );
	}

	return 0;
}
/*****************************************************************
 *		ե
 *		̾ꤹȥꥨե륿ס ֤
 *		֤ͤ -1 ʤ鼺ԡ
 */
s32 n64dd_get_file_info_by_name( char *filename, u32 *fsize, u8 *creator, u8 *filetype, LEODiskTime *ftime )
{
	int num;

	/* ǥξ֥å */
	if ( n64dd_check_valid() < 0 ) return -1;

	/* եγǼ֤õ */
	if ( (num = n64dd_search_name( filename )) < 0 ){
		n64dd_error_no = N64DD_NOT_FOUND;
		return -1;
	}

	/* եơ֥Ÿ */
	n64dd_expand_info( num );

	/* ե륵򥲥å */
	if ( fsize ){
		*fsize = n64dd_expanded_table.size;
	}

	/* ꥨ򥲥å */
	if ( creator ){
		bcopy ( creator, n64dd_expanded_table.creator, 4 );
	}

	/* ե륿פ򥲥å */
	if ( filetype ){
		bcopy ( filetype, n64dd_expanded_table.filetype, 4 );
	}
	return 0;
}
/*****************************************************************
 *		Ĥ LBA (Хȿ)롣
 */
s32 n64dd_left_LBAbyte( void )
{
	n64dd_FAT 	*f;
	s32			sumbyte;	/* ݥХȤ߷ */
	s32			leftbytes;	/* ꥢץХ */
	s32			sumLBA;		/* Ϣ³Ƥݲǽ LBA  */
	int			ws0, ws1;

	/* ==== ǥξ֥å */
	if ( n64dd_check_valid() < 0 ) return -1;

	/* եơ֥ */
	f = (n64dd_FAT*)n64dd_t.a;

	/* ĤХȿ */
	leftbytes = 0;
	for( ws0=1;  ws0<=(n64dd_cap.endLBA - n64dd_cap.startLBA); ws0++ ){

		/* ޤΰƬõ */
		if ( f->use[ ws0>>3 ] & ( 1 << ( 7-( ws0 & 7 ) ) ) ) continue;
		
		/* ֥åϢ³Хȿ׻ */
		ws1 = ws0;
		sumLBA = 0;
	
		while( ws1 <= (n64dd_cap.endLBA - n64dd_cap.startLBA) ){
			if ( f->use[ ws1>>3 ] & ( 1 << ( 7-( ws1&7 ) ) ) ) break;
			sumLBA ++;
			ws1++;
		}
		/*osSyncPrintf( "from %x : %x blocks.\n", ws0, sumLBA );*/
		LeoLBAToByte( n64dd_cap.startLBA + ws0, sumLBA, &sumbyte );
		leftbytes += sumbyte;
		ws0 = ws1;
	}

	return leftbytes;
}

/*****************************************************************
 *		ǥ ID 
 */
s32 n64dd_read_diskID( LEODiskID *id )
{
	LEOCmd			cmdBlock;

	if ( LeoReadDiskID( &cmdBlock, id, &diskQ ) < 0 ){
		n64dd_error_no = N64DD_MANAGER_NOT_CREATED;
		return -1;
	}

	osRecvMesg( &diskQ, (OSMesg *)&n64dd_error_no, OS_MESG_BLOCK );
	if ( n64dd_error_no ) return -1;

	return 0;
}

/*****************************************************************
 *		ǥޤäƤ뤫Ĵ٤
 *		1...ޤäƤ  0...ޤäƤʤ   -1...顼
 *		(԰¡)
 */
s32 n64dd_check_insert( void )
{
	LEOStatus status;

	if ( LeoTestUnitReady( &status ) < 0 ){
		n64dd_error_no = N64DD_MANAGER_NOT_CREATED;
	}

	osRecvMesg( &diskQ, (OSMesg *)&n64dd_error_no, OS_MESG_NOBLOCK );

	if ( n64dd_error_no ){
		if ( n64dd_error_no == LEO_ERROR_MEDIUM_NOT_PRESENT ) return 0;			/* ޤäƤʤ */
		if ( n64dd_error_no == LEO_ERROR_MEDIUM_MAY_HAVE_CHANGED ) return 1;	/* 򴹤줿(ǤޤäƤ) */
		return -1;
	}

	/*osSyncPrintf( "status %d  error %d\n", status, n64dd_error_no );*/

	if ( (status & LEO_TEST_UNIT_MR) == 0 ) return 1;

	n64dd_error_no = LEO_ERROR_MEDIUM_NOT_PRESENT;
	return 0;
}

/*****************************************************************
 *		ǥ狼å
 *			֤ -1...   0...
 *			ޤ n64dd_error_no ǥåƤ褤
 *				 λɬ 0
 *				 λɬ 0ʳ
 */
s32 n64dd_check_valid( void )
{
	n64dd_error_no = 0;

	/* ǥ狼 */
	n64dd_always_error_check();

	/* ǥ¸ߤ뤫 */
	if ( n64dd_check_insert() <= 0 ){
		return -1;
	}

	/* ơ֥뤬ɤ߹ޤƤ뤫 */
	if ( n64dd_check_keyword() < 0 ){
		switch( n64dd_check_media_init() ){
		case 0:
			/* ǥΡեޥåȤƤʤ*/
			n64dd_error_no = N64DD_MEDIA_NOT_INIT;
			return -1;
		case -1:
			/* ¾μ */
			return -1;
		}
	}

	return 0;
}

/*****************************************************************
 *		եξܺ(FAT ΰ֤Ȥ)
 */
s32 n64dd_get_file_info_pointer( s16 fnum, n64dd_File_info **e )
{
	n64dd_FAT	*f;
	int			i, j;

	/* ǥξ֥å */
	if ( n64dd_check_valid() < 0 ) return -1;

	/* եơ֥ */
	f = (n64dd_FAT*)n64dd_t.a;
	
	/* ե */
	j = fnum;
	for( i=0; i<n64dd_ftablelen; i++ ){
		if ( f->fat[i].use == 1 )
			if ( j-- == 0 ) break;
	}

	/* ե뤬Ĥʤ */
	if ( j >= 0 ){
		n64dd_error_no = N64DD_NOT_FOUND;
		return -1;
	}

	/* եơ֥Ÿ */
	n64dd_expand_info( i );

	/* 󥨥ꥢ */
	*e = &n64dd_expanded_table;

	return 0;
}

/*================================================================
 *
 */

/*****************************************************************
 *		LeoReadWrite  READ 顼åäƤޤ
 */

s32 n64dd_LeoReadWrite_READ( u32 startLBA, void *vaddr, u32 nLBAs )
{
	LEOCmd		cmdBlock;
	int			i;
	s32			sumbyte;

	/* RDRAMɥ쥹Ⱦüɤ */
	if ( ( (s32)vaddr & 0xf ) == 0 ){
		if ( LeoReadWrite( &cmdBlock, OS_READ, startLBA, vaddr, nLBAs, &diskQ ) < 0 ){
			n64dd_error_no = N64DD_MANAGER_NOT_CREATED;
			return -1;
		}
		osRecvMesg( &diskQ, (OSMesg*)&n64dd_error_no, OS_MESG_BLOCK );
		if ( n64dd_error_no ) return -1;

		/* ǡå饤̵ */
		LeoLBAToByte( startLBA, nLBAs, &sumbyte );
		osInvalDCache( vaddr, sumbyte );

		/* 顼å */
		n64dd_error_no = GET_ERROR( cmdBlock );
		if ( n64dd_error_no ){
			return -1;									/* : n64dd_error_no ˸ */
		}
	}
	/* RDRAMɥ쥹Ⱦüä */
	else{
		for( i=0; i<nLBAs; i++ ){
			if ( LeoReadWrite( &cmdBlock, OS_READ, startLBA + i, n64dd_t.a, 1, &diskQ ) < 0 ){
				n64dd_error_no = N64DD_MANAGER_NOT_CREATED;
				return -1;
			}
			osRecvMesg( &diskQ, (OSMesg*)&n64dd_error_no, OS_MESG_BLOCK );
			if ( n64dd_error_no ) return -1;

			/* ǡå饤̵ */
			LeoLBAToByte( startLBA + i, 1, &sumbyte );
			osInvalDCache( vaddr, sumbyte );

			/* 顼å */
			n64dd_error_no = GET_ERROR( cmdBlock );
			if ( n64dd_error_no ){
				return -1;									/* : n64dd_error_no ˸ */
			}
			
			/* ХåեŪΰ */
			bcopy( n64dd_t.a, vaddr, sumbyte );

			/* եơ֥ǤʤȤݾ */
			n64dd_t.a[0] = '\0';

			vaddr = (u8*)vaddr + sumbyte;
		}
	}
	return 0;
}

/*****************************************************************
 *		LeoReadWrite  WRITE 顼åäƤޤ
 */

s32 n64dd_LeoReadWrite_WRITE( u32 startLBA, void *vaddr, u32 nLBAs )
{
	LEOCmd		cmdBlock;
	int			i;
	s32			sumbyte;

	/* RDRAMɥ쥹Ⱦüɤ */
	if ( ( (s32)vaddr & 0xf ) == 0 ){
		if ( LeoReadWrite( &cmdBlock, OS_WRITE, startLBA, vaddr, nLBAs, &diskQ ) < 0 ){
			n64dd_error_no = N64DD_MANAGER_NOT_CREATED;
			return -1;
		}
		osRecvMesg( &diskQ, (OSMesg*)&n64dd_error_no, OS_MESG_BLOCK );
		if ( n64dd_error_no ) return -1;

		/* 顼å */
		n64dd_error_no = GET_ERROR( cmdBlock );
		if ( n64dd_error_no ){
			return -1;									/* : n64dd_error_no ˸ */
		}
	}
	/* RDRAMɥ쥹Ⱦüä */
	else{
		for( i=0; i<nLBAs; i++ ){
			LeoLBAToByte( startLBA + i, 1, &sumbyte );

			/* ХåեŪΰ */
			bcopy( vaddr, n64dd_t.a, sumbyte );

			/*  */
			if ( LeoReadWrite( &cmdBlock, OS_WRITE, startLBA + i, n64dd_t.a, 1, &diskQ ) < 0 ){
				n64dd_error_no = N64DD_MANAGER_NOT_CREATED;
				return -1;
			}
			osRecvMesg( &diskQ, (OSMesg*)&n64dd_error_no, OS_MESG_BLOCK );
			if ( n64dd_error_no ) return -1;

			/* եơ֥ǤʤȤݾ */
			n64dd_t.a[0] = '\0';

			/* 顼å */
			n64dd_error_no = GET_ERROR( cmdBlock );
			if ( n64dd_error_no ){
				return -1;									/* : n64dd_error_no ˸ */
			}

			vaddr = (u8*)vaddr + sumbyte;
		}
	}
	return 0;
}


#define connect_pointer( num, fp );		{ if ( fp >= N64DD_INFO_SIZE ){ num = f->fat[num].connect; fp = 0; } }
#define check_over_table( num );		{ if ( num > n64dd_ftablelen ){ n64dd_error_no = N64DD_DISK_DAMAGED; return -1; } }

/*****************************************************************
 *		եŸ
 */
u32 n64dd_expand_info( int num )
{
	n64dd_FAT 			*f = (n64dd_FAT*)n64dd_t.a;
	n64dd_File_info		*e = &n64dd_expanded_table;

	int		pos = 0;
	int		fp = 0;

	/* ̾Ÿ */
	while(1){
		if ( ( e->name[pos] = f->fat[num].info[fp] )  == '\0' )	break;
		pos++;
		fp++;

		connect_pointer( num, fp );
		check_over_table( num );
	}

	/* ե륵򥲥å */
	fp = ( fp + 4 ) & 0xfffc;
	connect_pointer( num, fp );
	check_over_table( num );
	e->size = *(u32*)&(f->fat[num].info[fp]);
	fp += 4;

	/* ꥨ򥲥å */
	connect_pointer( num, fp );
	check_over_table( num );
	for( pos = 0; pos < 4; pos++ )
		e->creator[pos] = *(u8*)&(f->fat[num].info[fp++]);

	/* ե륿פ򥲥å */
	connect_pointer( num, fp );
	check_over_table( num );
	for( pos = 0; pos < 4; pos++ )
		e->filetype[pos] = *(u8*)&(f->fat[num].info[fp++]);

	/* ե(Ⱦ) */
	connect_pointer( num, fp );
	check_over_table( num );
	for( pos = 0; pos < 4; pos++ )
		*((u8*)&(e->time) + pos) = *(u8*)&(f->fat[num].info[fp++]);

	/* ե(Ⱦ) */	
	connect_pointer( num, fp );
	check_over_table( num );
	for( pos = 0; pos < 4; pos++ )
		*((u8*)&(e->time) + pos + 4) = *(u8*)&(f->fat[num].info[fp++]);

	/* ǼȤ򥲥å */
	for( pos = 0; pos < N64DD_MAX_INFO_PAIR; pos ++ ){
		connect_pointer( num, fp );

		/* λå(1) */
		if ( num == 0xffff ){
			e->info[pos].startLBA = 0x0;
			e->info[pos].useLBA   = 0x0;
			break;
		}
		else{
			check_over_table( num );
		}

		e->info[pos].startLBA = *(u16*)&(f->fat[num].info[fp]);
		fp += 2;
		e->info[pos].useLBA   = *(u16*)&(f->fat[num].info[fp]);
		fp += 2;
		
		/* λå(2) */
		if ( e->info[pos].startLBA == 0 ) break;
	}

	return 0;	
}
/*****************************************************************
 *		Ÿ(̾)
 */
u32 n64dd_expand_info_name( int num )
{
	n64dd_FAT 					*f = (n64dd_FAT*)n64dd_t.a;
	n64dd_File_info	*e = &n64dd_expanded_table;

	int		pos = 0;
	int		fp = 0;

	/* ̾Ÿ */
	while(1){
		if ( ( e->name[pos] = f->fat[num].info[fp] )  == '\0' )	break;
		pos++;
		fp++;

		connect_pointer( num, fp );
		check_over_table( num );
	}

	return 0;
}
/*****************************************************************/



/*================================================================================================================================
 *	Ѵؿ
 */

/*****************************************************************
 *		ʸ
 */
int n64dd_strcmp( char *str1, char *str2 )
{
	char *s1 = str1;
	char *s2 = str2;

	while( *s1 )		if ( *s1++ != *s2++ ) return -1;

	if ( *s2 == '\0' ) return 0;
	return -1;
}
/*****************************************************************
 *		ʸĹ( ɥޡޤޤʤ )
 */
int n64dd_strlen( char *str )
{
	int   len = 0;

	if ( !str ) return 0;
	while( *(str++) ) len++;

	return len;
}
/*****************************************************************
 *		ʸʣ
 *		str1  str2 '\0' ޤʣ̤롣
 */
int n64dd_strcpy( char *str1, char *str2 )
{
	char *s1 = str1;
	char *s2 = str2;

	while( *s2 )	*s1++ = *s2++;

	*s1 = '\0';

	return 0;
}
/*****************************************************************
 *		ʸϢ
 *		str1  str2 Ϣ뤹롣str1 Τ str2 ʣ̤Ȥʤ롣
 */
int n64dd_strcat( char *str1, char *str2 )
{
	char *s1 = str1;
	char *s2 = str2;

	while( *s1 )	s1++;
	while( *s2 )	*s1++ = *s2++;

	*s1 = '\0';

	return 0;
}

/*****************************************************************
 *		bcd -> dec Ѵ
 */
int n64dd_bcd_dec( int bcd )
{
	return (bcd>>4)*10 + (bcd & 0xf);
}
/*****************************************************************
 *		dec -> bcd Ѵ
 */
int n64dd_dec_bcd( int dec )
{
	return (dec/10) * 16 + dec % 10;
}

/* ================================================================
 *		RTC ؿ
 */
/*****************************************************************
 *		RTC ˻Ͽ
 */
s32 n64dd_set_RTC_BCD( int year, int month, int day, int hour, int minute, int second )
{
	LEOCmd		cmdBlock;

	n64dd_expanded_table.time.pad = 0;
	n64dd_expanded_table.time.yearhi = ( year > 0x1900 )? (year / 0x100): ( (year > 0x96)? 0x19: 0x20 ); /* ǰΤ */
	n64dd_expanded_table.time.yearlo = year % 0x100;
	n64dd_expanded_table.time.month = month;
	n64dd_expanded_table.time.day = day;
	n64dd_expanded_table.time.hour = hour;
	n64dd_expanded_table.time.minute = minute;
	n64dd_expanded_table.time.second = second;

	if ( LeoSetRTC( &cmdBlock, &n64dd_expanded_table.time, &diskQ ) < 0 ){
		n64dd_error_no = N64DD_MANAGER_NOT_CREATED;
		return -1;
	}
	osRecvMesg( &diskQ, (OSMesg*)&n64dd_error_no, OS_MESG_BLOCK );
	if ( n64dd_error_no ) return -1;

	return 0;
}

/*****************************************************************/
s32 n64dd_set_RTC( int year, int month, int day, int hour, int minute, int second )
{
	return n64dd_set_RTC_BCD( n64dd_dec_bcd(year%100),
							n64dd_dec_bcd(month),
							n64dd_dec_bcd(day),
							n64dd_dec_bcd(hour),
							n64dd_dec_bcd(minute),
							n64dd_dec_bcd(second) );
}

/*****************************************************************
 *		RTC ɤ
 */
s32 n64dd_get_RTC_BCD( int *year, int *month, int *day, int *hour, int *minute, int *second )
{
	LEOCmd		cmdBlock;

	if ( LeoReadRTC( &cmdBlock, &diskQ ) < 0 ){
		n64dd_error_no = N64DD_MANAGER_NOT_CREATED;
		return -1;
	}

	osRecvMesg( &diskQ, (OSMesg*)&n64dd_error_no, OS_MESG_BLOCK );
	if ( n64dd_error_no ) return -1;

	if ( year   ) *year    = cmdBlock.data.time.yearlo;
	if ( month  ) *month   = cmdBlock.data.time.month;
	if ( day    ) *day     = cmdBlock.data.time.day;
	if ( hour   ) *hour    = cmdBlock.data.time.hour;
	if ( minute ) *minute  = cmdBlock.data.time.minute;
	if ( second ) *second  = cmdBlock.data.time.second;
	
	return 0;
}

/*****************************************************************/
s32 n64dd_get_RTC( int *year, int *month, int *day, int *hour, int *minute, int *second )
{
	int		year0, month0, day0, hour0, minute0, second0;

	if ( n64dd_get_RTC_BCD( &year0, &month0, &day0, &hour0, &minute0, &second0 ) < 0 ) return -1;

	if ( year   ) *year    = n64dd_bcd_dec( year0 );
	if ( month  ) *month   = n64dd_bcd_dec( month0 );
	if ( day    ) *day     = n64dd_bcd_dec( day0 );
	if ( hour   ) *hour    = n64dd_bcd_dec( hour0 );
	if ( minute ) *minute  = n64dd_bcd_dec( minute0 );
	if ( second ) *second  = n64dd_bcd_dec( second0 );

	return 0;
}

/*****************************************************************
 *		RTC ɤ(raw ǡ)
 */
s32 n64dd_get_RTC_raw( LEODiskTime *time )
{
	LEOCmd		cmdBlock;

	if ( LeoReadRTC( &cmdBlock, &diskQ ) < 0 ){
		n64dd_error_no = N64DD_MANAGER_NOT_CREATED;
		return -1;
	}

	osRecvMesg( &diskQ, (OSMesg*)&n64dd_error_no, OS_MESG_BLOCK );
	if ( n64dd_error_no ) return -1;

	bcopy ( (void *)&(cmdBlock.data.time), time, sizeof( LEODiskTime ) );

	return 0;
}
/*================================================================*/
/*****************************************************************
 *	LeoRezero شؿ
 */
s32 n64dd_LeoRezero( void )
{
	LEOCmd		cmdBlock;

	if ( LeoRezero( &cmdBlock, &diskQ ) < 0 ){
		n64dd_error_no = N64DD_MANAGER_NOT_CREATED;
		return -1;
	}

	osRecvMesg( &diskQ, (OSMesg*)&n64dd_error_no, OS_MESG_BLOCK );
	if ( n64dd_error_no ) return -1;

	return 0;
}
/*****************************************************************
 *	LeoSeek شؿ
 */
s32 n64dd_LeoSeek( s32 lba )
{
	LEOCmd		cmdBlock;

	if ( LeoSeek( &cmdBlock, lba, &diskQ ) < 0 ){
		n64dd_error_no = N64DD_MANAGER_NOT_CREATED;
		return -1;
	}

	osRecvMesg( &diskQ, (OSMesg*)&n64dd_error_no, OS_MESG_BLOCK );
	if ( n64dd_error_no ) return -1;

	return 0;
}
/*****************************************************************
 *	LeoSpdlMotor شؿ
 */
s32 n64dd_LeoSpdlMotor( LEOSpdlMode mode )
{
	LEOCmd		cmdBlock;

	if ( LeoSpdlMotor( &cmdBlock, mode, &diskQ ) < 0 ){
		n64dd_error_no = N64DD_MANAGER_NOT_CREATED;
		return -1;
	}

	osRecvMesg( &diskQ, (OSMesg*)&n64dd_error_no, OS_MESG_BLOCK );
	if ( n64dd_error_no ) return -1;

	return 0;
}
/*================================================================================================================================
 *	鲼ϥǥХåѤǤ
 */
