/*****************************************************************
 *
 *		n64dd 饤֥إå version 2.6   97/05/09
 *
 *****************************************************************/

#ifndef _LEO_H_
	#include <leo.h>
#endif


/*****************************************************************
 *		
 */
#ifndef __N64DD_H

/* ---- DISK ʸȤʸ ---- */
#define	N64DD_IDSTR				"64dd"
#define	N64DD_IDSTRLEN			4

/* ---- ѥե饰ΰ(byte) ---- */
#define	N64DD_USEBITLEN			368

/* ----  FTABLE Ĺ(ܿ) ---- */
#define	N64DD_MAX_FTABLELEN		996

/* ---- եơ֥ΰ礭(byte) ---- */
#define	N64DD_FTABLE_WORK		16000

/* ---- (readonly ΰޤ)ǥLBAκХȿ ---- */
#define N64DD_MAX_BYTE_PER_BLOCK	19728

/* ---- 顼 ---- */
#define N64DD_MEDIA_NOT_INIT	   0xf0
#define N64DD_AREA_LACKED		   0xf1
#define N64DD_NOT_FOUND			   0xf2
#define N64DD_DISK_DAMAGED		   0xf3
#define N64DD_ARGUMENT_ILLEGAL	   0xf4
#define N64DD_DISKID_ILLEGAL       0xf5
#define N64DD_READ_ONLY_MEDIA      0xf6
#define N64DD_MANAGER_NOT_CREATED  0xf7

/* ---- եơ֥룱ĤΤξΰ ---- */
#define N64DD_INFO_SIZE			12
#define	N64DD_MAX_INFO_PAIR		1024

/* ---- ֡ȷ ---- */
#define	N64DD_CARTRIDGE_BOOT	1
#define	N64DD_DISK_BOOT			2

#endif	/* __N64DD_H */

/*****************************************************************
 *		¤Ρ
 */
#ifndef __N64DD_H

/* ================ ե Υơ֥빽¤ */
typedef	struct{
	u8				info[ N64DD_INFO_SIZE ];
	u16				use;
	u16				connect;
} n64dd_Table;



/* ================ եơ֥Τι¤ */
typedef struct{
	u8				diskID[ 16 ];
	u8				use[ N64DD_USEBITLEN ];
	n64dd_Table		fat[ N64DD_MAX_FTABLELEN ];
} n64dd_FAT;



/* ================ ե ι¤ */
typedef struct{
	u16		startLBA;
	u16		useLBA;
	
} n64dd_Info_pair;


typedef struct{
	char				name[ 256 ];
	u32					size;
	u8					creator[ 4 ];
	u8					filetype[ 4 ];
	LEODiskTime			time;
	n64dd_Info_pair		info[ N64DD_MAX_INFO_PAIR + 1 ];
} n64dd_File_info;



/* ================ */
typedef union{
	u8						a[ N64DD_MAX_BYTE_PER_BLOCK ];	/* ==== ǥȥХåե */
	n64dd_FAT				fat;
	u64						dummy_alignment_for_n64dd_t[ ( N64DD_MAX_BYTE_PER_BLOCK + 7 )>>3 ];
} n64dd_Disk_buffer;

typedef union{
	u8			a[ N64DD_USEBITLEN ];			/* ==== FAT ѥӥåȺȤΤ */
	u64			dummy_alignment_for_n64dd_file[ ( N64DD_USEBITLEN + 7 )>>3 ];
} n64dd_File_usebit_work;

#endif	/* __N64DD_H */

/*****************************************************************
 *		ѿγ
 */

#ifndef __N64DD_C

extern 	OSMesgQueue			diskQ;				/* 塼 */
extern	OSMesg				diskQBuf;

extern	LEOCapacity			n64dd_cap;			/* ǥͭ */

extern	s32					n64dd_error_no;		/* 顼ֹ */

extern 	n64dd_Disk_buffer	n64dd_t;			/* ΰ */

extern	LEODiskID			n64dd_myDiskID;		/* ߰äƤǥID */

#endif	/* __N64DD_C */

/*****************************************************************
 *		ؿץȥ
 */

/*  */
void n64dd_createQ( void );
s32 n64dd_create_manager( void );
s32 n64dd_create_manager0( int media );
s32	n64dd_newdisk( void );


/* å */
s32 n64dd_check( void );
s32 n64dd_check_media_init( void );
s32 n64dd_check_keyword( void );


/* եޥå */
s32 n64dd_media_init( void );


/* ե븡 */
s32 n64dd_search_name( char* name );


/*  */
s32 n64dd_save( char* name, u32*, s32, char*, char* );
s32 n64dd_save_deletefirst( char*, u32*, s32, char*, char* );
s32 n64dd_save_samearea( char*, u32* );
s32 n64dd_create_file( char*, u32*, s32, char*, char* );

/*  */
s32 n64dd_load( char*, u32*, s32 );
s32 n64dd_load_halfway( char*, u32*, s32, s32 );


/* ΰؤϿ */
s32 n64dd_resist_name( char* );
s32 n64dd_resist_bytes( u32 );
s32 n64dd_resist_creator( char* );
s32 n64dd_resist_filetype( char* );
s32 n64dd_resistLBA( s16, s16 );
s32 n64dd_resist_createtime( void );


s32 n64dd_ftable_blank( void );
s32 n64dd_write_bytes( u32, u32 );
s32 n64dd_write_area( u32, u32 );
s32 n64dd_ftable_flush( void );
s32 n64dd_write_tmpfat( void );
s32 n64dd_set_usebit( s16, s16 );
s32 n64dd_unset_usebit( s16, s16 );
s32 n64dd_import_usebit( void );
s32 n64dd_export_usebit( void );
s32 n64dd_search_blankLBA( s32, s16*, s16*, s32* );


/* ե */
s32 n64dd_delete_file( char* );
s32 n64dd_delete_file_sub( char* );
s32 n64dd_rename_file( char*, char* );
s32 n64dd_delete_usebit( void );
s32 n64dd_delete_ftable( s32 );


/* ե */
s32 n64dd_how_many_file( void );

s32 n64dd_ftable_left( void );
s32 n64dd_get_file_info( s16, char*, u32*, u8*, u8*, LEODiskTime *ftime );
s32 n64dd_get_file_info_by_name( char*, u32*, u8*, u8*, LEODiskTime *ftime );
s32 n64dd_left_LBAbyte( void );
s32 n64dd_read_diskID( LEODiskID* );
s32 n64dd_check_insert( void );
s32 n64dd_check_valid( void );
s32 n64dd_get_file_info_pointer( s16 fnum, n64dd_File_info **e );


/* Ѵؿ */
int n64dd_strcmp( char*, char* );
int n64dd_strlen( char* );
int n64dd_strcpy( char*, char* );
int n64dd_strcat( char*, char* );
int n64dd_bcd_dec( int bcd );
int n64dd_dec_bcd( int dec );

/* ǥɤ߽ */
s32 n64dd_LeoReadWrite_READ ( u32, void*, u32 );
s32 n64dd_LeoReadWrite_WRITE( u32, void*, u32 );


/* եŸ */
u32 n64dd_expand_info( int num );
u32 n64dd_expand_info_name( int num );


/* RTC */
s32 n64dd_set_RTC_BCD( int year, int month, int day, int hour, int minute, int second );
s32 n64dd_set_RTC    ( int year, int month, int day, int hour, int minute, int second );
s32 n64dd_get_RTC_BCD( int *year, int *month, int *day, int *hour, int *minute, int *second );
s32 n64dd_get_RTC    ( int *year, int *month, int *day, int *hour, int *minute, int *second );
s32 n64dd_get_RTC_raw( LEODiskTime *time );


/* ¾Ʊؿ */
s32 n64dd_LeoRezero( void );
s32 n64dd_LeoSeek( s32 lba );
s32 n64dd_LeoSpdlMotor( LEOSpdlMode mode );

#define __N64DD_H
