#include <ultra64.h>
#include "define.h"


static Vp vp = {
	SCREEN_WD*2, SCREEN_HT*2, G_MAXZ/2, 0,	/* scale */
	SCREEN_WD*2, SCREEN_HT*2, G_MAXZ/2, 0,	/* translate */
};

/* ================ ңӣХơȽ */
Gfx rspinit_dl[] = {
    gsSPViewport(&vp),
    gsSPClearGeometryMode( 0xffffffff ),
    gsSPTexture( 0, 0, 0, 0, G_OFF ),
    gsSPEndDisplayList(),
};

/* ================ ңģХơȽ */
Gfx rdpinit_dl[] = {
    gsDPSetCycleType(G_CYC_1CYCLE),
    gsDPPipelineMode(G_PM_1PRIMITIVE),
    gsDPSetScissor(G_SC_NON_INTERLACE, 0, 0, SCREEN_WD, SCREEN_HT),
    gsDPSetTextureLOD(G_TL_TILE),
    gsDPSetTextureLUT(G_TT_NONE),
    gsDPSetTextureDetail(G_TD_CLAMP),
    gsDPSetTexturePersp(G_TP_PERSP),
    gsDPSetTextureFilter(G_TF_BILERP),
    gsDPSetTextureConvert(G_TC_FILT),
    gsDPSetCombineMode(G_CC_SHADE, G_CC_SHADE),
    gsDPSetCombineKey(G_CK_NONE),
    gsDPSetAlphaCompare(G_AC_NONE),
    gsDPSetRenderMode(G_RM_OPA_SURF, G_RM_OPA_SURF2),
    gsDPSetColorDither(G_CD_DISABLE),
    gsDPPipeSync(),
    gsSPEndDisplayList(),
};

/* ================ 顼ե졼Хåեꥢ */
Gfx clearcfb_dl[] = {
    gsDPSetCycleType(G_CYC_FILL),
    gsDPSetColorImage(G_IM_FMT_RGBA, G_IM_SIZ_16b, SCREEN_WD, rsp_cfb),
    gsDPSetFillColor(GPACK_RGBA5551(30,0,0,1) << 16 | GPACK_RGBA5551(30,0,0,1)),
    gsDPFillRectangle(0, 0, SCREEN_WD-1, SCREEN_HT-1),
    gsDPPipeSync(),
    gsDPSetCycleType(G_CYC_1CYCLE),
    gsSPEndDisplayList(),
};

/*****************************************************************
 * shadetri  ǥץ쥤ꥹ
 */
static Vtx shade_vtx[] =  {
        {        -16,  16, -5, 0, 0, 0, 0, 0xff, 0, 0xff	},
        {         16,  16, -5, 0, 0, 0, 0, 0, 0, 0xff	},
        {         16, -16, -5, 0, 0, 0, 0, 0, 0xff, 0xff	},
        {        -16, -16, -5, 0, 0, 0, 0xff, 0, 0, 0xff	},
};

Gfx shadetri_dl[] = {
    gsSPMatrix(OS_K0_TO_PHYSICAL(&(dynamic.projection)),   G_MTX_PROJECTION|G_MTX_LOAD|G_MTX_NOPUSH ),
    gsSPMatrix(OS_K0_TO_PHYSICAL(&(dynamic.modeling)),     G_MTX_MODELVIEW|G_MTX_LOAD|G_MTX_NOPUSH ),

    gsDPPipeSync(),
    gsDPSetCycleType(G_CYC_1CYCLE),
    gsDPSetRenderMode(G_RM_AA_OPA_SURF, G_RM_AA_OPA_SURF2),
    gsSPSetGeometryMode(G_SHADE | G_SHADING_SMOOTH),
	gsDPSetCombineMode( G_CC_SHADE, G_CC_SHADE ),

    gsSPVertex(&(shade_vtx[0]), 4, 0),
    gsSP1Triangle(0, 1, 2, 0),
    gsSP1Triangle(0, 2, 3, 0),
    gsSPEndDisplayList(),
};

/*****************************************************************
 *	Texture rectangle ν
 */
Gfx prepare_rectangle_dl[] = {
	gsDPPipeSync(),

	gsDPSetCycleType( G_CYC_1CYCLE ),
	gsSPClearGeometryMode( 0xffffffff ),
	gsSPSetGeometryMode( G_ZBUFFER | G_CULL_BACK | G_LIGHTING | G_TEXTURE_GEN ),
	gsSPTexture( 0x8000, 0x8000, 0, G_TX_RENDERTILE, G_ON ),
	gsDPSetCombineMode( G_CC_DECALRGBA, G_CC_DECALRGBA ),

	/*gsDPSetRenderMode( G_RM_AA_ZB_OPA_SURF, G_RM_AA_ZB_OPA_SURF2 ),*/
	gsDPSetRenderMode( G_RM_AA_TEX_EDGE, G_RM_AA_TEX_EDGE ),

	gsDPSetTextureFilter( G_TF_POINT ),
	gsDPSetTexturePersp( G_TP_NONE ),

#ifdef NEVER
	gsDPLoadTextureBlock( kirby_tex, G_IM_FMT_RGBA, G_IM_SIZ_16b, 32, 32, 0,
						  G_TX_WRAP , G_TX_WRAP,
						  5, 5, G_TX_NOLOD, G_TX_NOLOD ),

	gsSPTextureRectangle( 280<<2, 200<<2, 311<<2, 231<<2, 0, 0<<5, 0<<5, 1<<10, 1<<10 ),
#endif

	gsSPEndDisplayList(),
};

/*****************************************************************
 *		ʸβ
 */

static Gfx underchar_tex_C_dummy_aligner1[] = { gsSPEndDisplayList() };
unsigned char underchar_tex[] = {
	0x4c, 0x4c, 0x4c, 0x4c, 0x4c, 0x4c, 0x4c, 0x4c,
};

Gfx underchar_dl[] = {
	gsDPPipeSync(),

	gsDPSetCycleType( G_CYC_1CYCLE ),

	gsSPClearGeometryMode( 0xffffffff ),
	gsSPSetGeometryMode( G_ZBUFFER ),

	gsSPTexture( 0x8000, 0x8000, 0, G_TX_RENDERTILE, G_ON ),

    gsDPSetRenderMode( G_RM_XLU_SURF, G_RM_XLU_SURF2 ),
	gsDPSetCombineMode( G_CC_MODULATEIA_PRIM, G_CC_MODULATEIA_PRIM ),

    gsDPSetTextureFilter( G_TF_POINT ),
	gsDPSetTextureLOD( G_TL_TILE ),
	gsDPSetTextureConvert( G_TC_FILT ),
	gsDPSetTextureLUT( G_TT_NONE ),
    gsDPSetTexturePersp( G_TP_NONE ),

	gsDPLoadTextureBlock( underchar_tex, G_IM_FMT_IA, G_IM_SIZ_8b, 8, 1,
							 0,  G_TX_WRAP , G_TX_WRAP,
							 3, 0, G_TX_NOLOD, G_TX_NOLOD ),
	/*gsSPTextureRectangle( 10<<2, 10<<2, 150<<2, 230<<2, 0, 0, 0, 1<<10, 1<<10 ),*/

	/*gsDPPipeSync(),*/
	gsSPEndDisplayList(),
};
